import { AfterContentChecked, AfterContentInit, ElementRef, OnChanges, OnInit, QueryList, SimpleChanges } from '@angular/core';
import { PghFilterChipsComponent } from '@tapsellorg/angular-material-library/src/lib/filter-chips';
import { PghChartColorsService } from '../chart-colors.service';
import { PghChartStatBoxDirective } from '../chart-stat-box.directive';
import { PghStatBoxService } from '../statbox.service';
import { PghChartActiveStatBoxesChangeEvent, PghChartStatBox, PghGlobalChartOptions, PghMaxActiveChartBox } from '../models';
import { PghChartDateRangePickerDirective } from '../chart-date-range-picker.directive';
import { PghChartHeaderDirective } from '../chart-header.directive';
import * as i0 from "@angular/core";
declare const PghChartBoxComponent_base: (new (...args: any[]) => {
    _destroyed$: import("rxjs").Subject<unknown>;
    ngOnDestroy(): void;
}) & (new (...args: any[]) => {});
export declare class PghChartBoxComponent extends PghChartBoxComponent_base implements OnInit, AfterContentChecked, AfterContentInit, OnChanges {
    statBoxService: PghStatBoxService;
    private chartColorsService;
    statBoxesDirectives?: QueryList<PghChartStatBoxDirective>;
    filterChipsComponent?: PghFilterChipsComponent;
    chartTitle: import("@angular/core").InputSignal<string | undefined>;
    activeMax: import("@angular/core").ModelSignal<PghMaxActiveChartBox>;
    colors: import("@angular/core").InputSignal<string[] | undefined>;
    disableChartBoxScroll: import("@angular/core").ModelSignal<boolean>;
    activeStatBoxesChange: import("@angular/core").OutputEmitterRef<PghChartActiveStatBoxesChangeEvent<any>>;
    statBoxesScroller?: ElementRef<HTMLDivElement>;
    dateRangePickerDirective: typeof PghChartDateRangePickerDirective;
    headerDirective?: PghChartHeaderDirective;
    displayStatBoxesVertically: import("@angular/core").InputSignal<boolean>;
    isContainerOverflown: import("@angular/core").WritableSignal<boolean>;
    isContainerAtStart: import("@angular/core").WritableSignal<boolean>;
    isContainerAtEnd: import("@angular/core").WritableSignal<boolean>;
    constructor(statBoxService: PghStatBoxService, chartColorsService: PghChartColorsService, chartOptions: PghGlobalChartOptions);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    private handleActiveMaxChange;
    ngAfterContentInit(): void;
    ngAfterContentChecked(): void;
    private statBoxesTemplateChanged;
    private updateStatBoxesBasedOnDirectives;
    changeStatBoxActiveState(statBox: PghChartStatBox, statBoxContainerElm?: HTMLDivElement): void;
    shift(direction: number): void;
    isStatBoxesContainerOverflown(): boolean;
    scrollIntoView(element: HTMLElement | undefined): void;
    statBoxContainerScrollHandler(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghChartBoxComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghChartBoxComponent, "pgh-chart-box", never, { "chartTitle": { "alias": "chartTitle"; "required": false; "isSignal": true; }; "activeMax": { "alias": "activeMax"; "required": false; "isSignal": true; }; "colors": { "alias": "colors"; "required": false; "isSignal": true; }; "disableChartBoxScroll": { "alias": "disableChartBoxScroll"; "required": false; "isSignal": true; }; "displayStatBoxesVertically": { "alias": "displayStatBoxesVertically"; "required": false; "isSignal": true; }; }, { "activeMax": "activeMaxChange"; "disableChartBoxScroll": "disableChartBoxScrollChange"; "activeStatBoxesChange": "activeStatBoxesChange"; }, ["filterChipsComponent", "dateRangePickerDirective", "headerDirective", "statBoxesDirectives"], ["[pgh-chart-header]", "[pgh-chart-date-range-picker]", "pgh-filter-chips", "[pgh-chart-filters]", "[pgh-action-buttons]", "*"], false, never>;
}
export {};
