import { PghStatBoxService } from './statbox.service';
import { PghChartColorsService } from './chart-colors.service';
import { PghChartTooltipFormatter, PghSimpleHighchartsSeries } from './models';
import Highcharts from 'highcharts';
import { PghChartTooltipService } from './chart-tooltip.service';
import { Signal } from '@angular/core';
export declare abstract class ChartParent {
    highcharts: typeof Highcharts;
    abstract series: Signal<PghSimpleHighchartsSeries<any>[]>;
    protected abstract CHART_PLACEHOLDER_SERIES: any[];
    protected abstract statBoxService?: PghStatBoxService;
    protected abstract chartColorsService: PghChartColorsService;
    protected abstract chartTooltipService: PghChartTooltipService;
    abstract userCustomChartOptions: Signal<Highcharts.Options>;
    abstract defaultSeriesType: Signal<string>;
    tooltip: import("@angular/core").WritableSignal<string | PghChartTooltipFormatter | null>;
    get hasNoData(): boolean;
    protected getChartSeriesColor(index: number): string;
    protected getChartSeries(): any[];
    protected createChartOptions(customOptions: Highcharts.Options): Highcharts.Options;
    protected getTooltipFormatter(): (data: Highcharts.TooltipFormatterContextObject) => string;
}
