import { CurrencyPipe, DecimalPipe, PercentPipe } from '@angular/common';
import { PghChartTooltipFormatter, PghChartXAxisTooltipFormat, PghChartYAxisTooltip, PghChartYAxisTooltipFormat, PghChartYAxisTooltipFormatter, PghSimpleHighchartsSeries } from './models';
import { TooltipFormatterContextObject } from 'highcharts';
import * as i0 from "@angular/core";
export declare class PghChartTooltipService {
    private currencyPipe;
    private percentPipe;
    private decimalPipe;
    constructor(currencyPipe: CurrencyPipe, percentPipe: PercentPipe, decimalPipe: DecimalPipe);
    getPredefinedYAxisFormatter(tooltipType: PghChartYAxisTooltip): PghChartYAxisTooltipFormatter;
    getPredefinedFormatter(tooltipType: string): PghChartTooltipFormatter;
    wrapTemplateOnFormatter(tooltip: PghChartTooltipFormatter, series: PghSimpleHighchartsSeries[]): (data: TooltipFormatterContextObject) => string;
    private applySeriesTooltipFormatters;
    fillUndefinedAxisFormattersWithDefaults(tooltip: string | PghChartTooltipFormatter, defaultValues: {
        yAxis?: PghChartYAxisTooltipFormat;
        xAxis?: PghChartXAxisTooltipFormat;
    }): string | PghChartTooltipFormatter;
    tooltipTemplate: (y: (string | number | null | undefined)[], x: string | number, data: TooltipFormatterContextObject) => string;
    numberFormatter: (point: TooltipFormatterContextObject) => string;
    percentFormatter: (point: TooltipFormatterContextObject) => string;
    percentPieFormatter: (point: TooltipFormatterContextObject) => string;
    currencyFormatter: (point: TooltipFormatterContextObject) => string;
    xAxisDateTimeFormatter: (data: TooltipFormatterContextObject) => string;
    xAxisDateFormatter: (data: TooltipFormatterContextObject) => string;
    xAxisTimeFormatter: (data: TooltipFormatterContextObject) => string;
    yAxisFormatters: Record<PghChartYAxisTooltipFormat | string, (data: TooltipFormatterContextObject) => string>;
    xAxisFormatters: Record<PghChartXAxisTooltipFormat | string, (data: TooltipFormatterContextObject) => string>;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghChartTooltipService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PghChartTooltipService>;
}
