import { AfterViewChecked, ElementRef, OnChanges, SimpleChanges } from '@angular/core';
import { ChartParent } from '../chart-parent';
import { PghChartTooltipService } from '../chart-tooltip.service';
import { PghStatBoxService } from '../statbox.service';
import { PghChartColorsService } from '../chart-colors.service';
import { PghChartTooltipFormatter, PghFullChartYAxis, PghGlobalChartOptions, PghSimpleHighchartsSeries } from '../models';
import { Chart, Options } from 'highcharts';
import * as i0 from "@angular/core";
export declare class PghFullChartComponent extends ChartParent implements OnChanges, AfterViewChecked {
    protected chartTooltipService: PghChartTooltipService;
    protected chartColorsService: PghChartColorsService;
    private globalChartOptions;
    protected statBoxService?: PghStatBoxService | undefined;
    private readonly MIN_ZOOM_ENABLED_CHART_SERIES;
    chartOptions: import("@angular/core").WritableSignal<Options>;
    userCustomChartOptions: import("@angular/core").InputSignal<Options>;
    series: import("@angular/core").InputSignal<PghSimpleHighchartsSeries<import("../models").PghSimpleChartData>[]>;
    defaultSeriesType: import("@angular/core").InputSignal<"areaspline" | "column">;
    xAxis: import("@angular/core").InputSignal<(string | Date)[]>;
    yAxis: import("@angular/core").ModelSignal<PghFullChartYAxis[]>;
    tooltip: import("@angular/core").ModelSignal<string | PghChartTooltipFormatter | null>;
    protected readonly CHART_PLACEHOLDER_SERIES: {
        name: string;
        data: number[];
        type: "areaspline" | "column";
    }[];
    chartWrapper?: ElementRef;
    private lastChartWrapperWidth?;
    private chartInstance?;
    /** TODO: 'chartColorsService' injected but never used review its usage if the 'updateColors' in its constructor doesn't do anything in this scenario */
    constructor(chartTooltipService: PghChartTooltipService, chartColorsService: PghChartColorsService, globalChartOptions: PghGlobalChartOptions, statBoxService?: PghStatBoxService | undefined);
    ngAfterViewChecked(): void;
    private handleChartReflow;
    ngOnChanges(changes: SimpleChanges): void;
    private getXAxis;
    private updateChartOptions;
    onSetChartInstance(chartInstance: Chart): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghFullChartComponent, [null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghFullChartComponent, "pgh-full-chart", never, { "userCustomChartOptions": { "alias": "customChartOptions"; "required": false; "isSignal": true; }; "series": { "alias": "series"; "required": false; "isSignal": true; }; "defaultSeriesType": { "alias": "seriesType"; "required": false; "isSignal": true; }; "xAxis": { "alias": "xAxis"; "required": false; "isSignal": true; }; "yAxis": { "alias": "yAxis"; "required": false; "isSignal": true; }; "tooltip": { "alias": "tooltip"; "required": false; "isSignal": true; }; }, { "yAxis": "yAxisChange"; "tooltip": "tooltipChange"; }, never, never, false, never>;
}
