import { AfterViewChecked, ElementRef, OnChanges, SimpleChanges } from '@angular/core';
import * as Highcharts from 'highcharts';
import { PghPieChartData, PghSimpleHighchartsSeries } from '../models';
import { PghChartTooltipService } from '../chart-tooltip.service';
import { ChartParent } from '../chart-parent';
import { PghChartColorsService } from '../chart-colors.service';
import { PghStatBoxService } from '../statbox.service';
import * as i0 from "@angular/core";
export declare class PghPieChartComponent extends ChartParent implements OnChanges, AfterViewChecked {
    protected chartTooltipService: PghChartTooltipService;
    protected chartColorsService: PghChartColorsService;
    protected statBoxService?: PghStatBoxService | undefined;
    chartOptions: import("@angular/core").WritableSignal<Highcharts.Options>;
    userCustomChartOptions: import("@angular/core").InputSignal<Highcharts.Options>;
    series: import("@angular/core").InputSignal<PghSimpleHighchartsSeries<PghPieChartData>[]>;
    tooltip: import("@angular/core").ModelSignal<string | null>;
    pieType: import("@angular/core").InputSignal<"pie" | "donut">;
    defaultSeriesType: import("@angular/core").WritableSignal<string>;
    chartWrapper?: ElementRef<HTMLDivElement>;
    private lastChartWrapperWidth?;
    private chartInstance?;
    protected CHART_PLACEHOLDER_SERIES: {
        name: string;
        value: number;
        type: string;
    }[];
    constructor(chartTooltipService: PghChartTooltipService, chartColorsService: PghChartColorsService, statBoxService?: PghStatBoxService | undefined);
    ngOnChanges(_changes: SimpleChanges): void;
    ngAfterViewChecked(): void;
    private handleChartReflow;
    configureChartOptions(): void;
    onSetChartInstance(chartInstance: Highcharts.Chart): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghPieChartComponent, [null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghPieChartComponent, "pgh-pie-chart", never, { "userCustomChartOptions": { "alias": "customChartOptions"; "required": false; "isSignal": true; }; "series": { "alias": "series"; "required": false; "isSignal": true; }; "tooltip": { "alias": "tooltip"; "required": false; "isSignal": true; }; "pieType": { "alias": "pieType"; "required": false; "isSignal": true; }; }, { "tooltip": "tooltipChange"; }, never, never, false, never>;
}
