import { OnInit, TemplateRef, ChangeDetectorRef } from '@angular/core';
import { PghConditionBuilderConfig, PghConditionBuilderValue, PghConditionOperators } from './models';
import { AbstractControl, ControlValueAccessor, UntypedFormArray, UntypedFormBuilder, UntypedFormControl, UntypedFormGroup } from '@angular/forms';
import * as i0 from "@angular/core";
export declare class PghConditionBuilderComponent implements OnInit, ControlValueAccessor {
    private formBuilder;
    private changeDetectorRef;
    conditionBuilderConfig: PghConditionBuilderConfig;
    filterControl: import("@angular/core").InputSignal<AbstractControl<any, any> | undefined>;
    addButtonText: import("@angular/core").InputSignal<string | undefined>;
    filterFormTemplateRef: TemplateRef<unknown>;
    conditionBuilderForm: UntypedFormGroup;
    onChange?: (value: PghConditionBuilderValue | null) => void;
    onTouched?: (value: PghConditionBuilderValue | null) => void;
    constructor(formBuilder: UntypedFormBuilder, changeDetectorRef: ChangeDetectorRef, conditionBuilderConfig: PghConditionBuilderConfig);
    ngOnInit(): void;
    get filters(): UntypedFormArray;
    get operator(): UntypedFormControl;
    addNewFilter(): void;
    onOperatorChange(event: PghConditionOperators): void;
    deleteFilter(index: number): void;
    private setupFormChangeValueListener;
    registerOnChange(fn: (value: PghConditionBuilderValue | null) => void): void;
    registerOnTouched(fn: (value: PghConditionBuilderValue | null) => void): void;
    writeValue(value: PghConditionBuilderValue | null): void;
    reset(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghConditionBuilderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghConditionBuilderComponent, "pgh-condition-builder", never, { "filterControl": { "alias": "filterControl"; "required": false; "isSignal": true; }; "addButtonText": { "alias": "addButtonText"; "required": false; "isSignal": true; }; }, {}, ["filterFormTemplateRef"], never, false, never>;
}
