import * as i0 from '@angular/core';
import { Injectable } from '@angular/core';
import * as i1 from '@angular/material/icon';
import * as i2 from '@angular/common/http';
import * as i3 from '@angular/platform-browser';

var icons = [
	"10k",
	"10mp",
	"11mp",
	"12mp",
	"13mp",
	"14mp",
	"15mp",
	"16mp",
	"17mp",
	"18mp",
	"19mp",
	"1k_plus",
	"1k",
	"1x_mobiledata",
	"20mp",
	"21mp",
	"22mp",
	"23mp",
	"24mp",
	"2k_plus",
	"2k",
	"2mp",
	"30fps_select",
	"30fps",
	"360",
	"3d_rotation",
	"3g_mobiledata",
	"3k_plus",
	"3k",
	"3mp",
	"3p",
	"4g_mobiledata",
	"4g_plus_mobiledata",
	"4k_plus",
	"4k",
	"4mp",
	"5g",
	"5k_plus",
	"5k",
	"5mp",
	"60fps_select",
	"60fps",
	"6_ft_apart",
	"6k_plus",
	"6k",
	"6mp",
	"7k_plus",
	"7k",
	"7mp",
	"8k_plus",
	"8k",
	"8mp",
	"9k_plus",
	"9k",
	"9mp",
	"access_alarms",
	"access_alarm",
	"accessibility_new",
	"accessibility",
	"accessible_forward",
	"accessible",
	"access_time_filled",
	"access_time",
	"account_balance",
	"account_balance_wallet",
	"account_box",
	"account_circle",
	"account_tree",
	"ac_unit",
	"adb",
	"add_alarm",
	"add_alert",
	"add_a_photo",
	"add_box",
	"add_business",
	"add_call",
	"add_chart",
	"addchart",
	"add_circle_outline",
	"add_circle",
	"add_comment",
	"add_ic_call",
	"add_link",
	"add_location_alt",
	"add_location",
	"add_moderator",
	"add_photo_alternate",
	"add_reaction",
	"add_road",
	"add_shopping_cart",
	"add",
	"add_task",
	"add_to_drive",
	"add_to_home_screen",
	"add_to_photos",
	"add_to_queue",
	"adjust",
	"admin_panel_settings",
	"ads_click",
	"ad_units",
	"agriculture",
	"airline_seat_flat_angled",
	"airline_seat_flat",
	"airline_seat_individual_suite",
	"airline_seat_legroom_extra",
	"airline_seat_legroom_normal",
	"airline_seat_legroom_reduced",
	"airline_seat_recline_extra",
	"airline_seat_recline_normal",
	"airplanemode_active",
	"airplanemode_inactive",
	"airplane_ticket",
	"airplay",
	"airport_shuttle",
	"air",
	"alarm_add",
	"alarm_off",
	"alarm_on",
	"alarm",
	"album",
	"align_horizontal_center",
	"align_horizontal_left",
	"align_horizontal_right",
	"align_vertical_bottom",
	"align_vertical_center",
	"align_vertical_top",
	"all_inbox",
	"all_inclusive",
	"all_out",
	"alternate_email",
	"alt_route",
	"amp_stories",
	"analytics",
	"anchor",
	"android",
	"animation",
	"announcement",
	"aod",
	"apartment",
	"api",
	"app_blocking",
	"app_registration",
	"approval",
	"app_settings_alt",
	"apps",
	"architecture",
	"archive",
	"area_chart",
	"arrow_back_ios_new",
	"arrow_back_ios",
	"arrow_back",
	"arrow_circle_down",
	"arrow_circle_up",
	"arrow_downward",
	"arrow_drop_down_circle",
	"arrow_drop_down",
	"arrow_drop_up",
	"arrow_forward_ios",
	"arrow_forward",
	"arrow_left",
	"arrow_right_alt",
	"arrow_right",
	"arrow_upward",
	"article",
	"art_track",
	"aspect_ratio",
	"assessment",
	"assignment_ind",
	"assignment_late",
	"assignment_returned",
	"assignment_return",
	"assignment",
	"assignment_turned_in",
	"assistant_direction",
	"assistant_navigation",
	"assistant_photo",
	"assistant",
	"atm",
	"attach_email",
	"attach_file",
	"attachment",
	"attach_money",
	"attractions",
	"attribution",
	"audiotrack",
	"auto_awesome_mosaic",
	"auto_awesome_motion",
	"auto_awesome",
	"auto_delete",
	"auto_fix_high",
	"auto_fix_normal",
	"auto_fix_off",
	"autofps_select",
	"auto_graph",
	"autorenew",
	"auto_stories",
	"av_timer",
	"baby_changing_station",
	"back_hand",
	"backpack",
	"backspace",
	"backup",
	"backup_table",
	"badge",
	"bakery_dining",
	"balcony",
	"ballot",
	"bar_chart",
	"batch_prediction",
	"bathroom",
	"bathtub",
	"battery_alert",
	"battery_charging_full",
	"battery_full",
	"battery_saver",
	"battery_std",
	"battery_unknown",
	"beach_access",
	"bedroom_baby",
	"bedroom_child",
	"bedroom_parent",
	"bed",
	"bedtime",
	"beenhere",
	"bento",
	"bike_scooter",
	"biotech",
	"blender",
	"block_flipped",
	"block",
	"bloodtype",
	"bluetooth_audio",
	"bluetooth_connected",
	"bluetooth_disabled",
	"bluetooth_drive",
	"bluetooth_searching",
	"bluetooth",
	"blur_circular",
	"blur_linear",
	"blur_off",
	"blur_on",
	"bolt",
	"bookmark_added",
	"bookmark_add",
	"bookmark_border",
	"bookmark_remove",
	"bookmarks",
	"bookmark",
	"book_online",
	"book",
	"border_all",
	"border_bottom",
	"border_clear",
	"border_color",
	"border_horizontal",
	"border_inner",
	"border_left",
	"border_outer",
	"border_right",
	"border_style",
	"border_top",
	"border_vertical",
	"branding_watermark",
	"breakfast_dining",
	"brightness_1",
	"brightness_2",
	"brightness_3",
	"brightness_4",
	"brightness_5",
	"brightness_6",
	"brightness_7",
	"brightness_auto",
	"brightness_high",
	"brightness_low",
	"brightness_medium",
	"broken_image",
	"browser_not_supported",
	"brunch_dining",
	"brush",
	"bubble_chart",
	"bug_report",
	"build_circle",
	"build",
	"bungalow",
	"burst_mode",
	"bus_alert",
	"business_center",
	"business",
	"cabin",
	"cable",
	"cached",
	"cake",
	"calculate",
	"calendar_today",
	"calendar_view_day",
	"calendar_view_month",
	"calendar_view_week",
	"call_end",
	"call_made",
	"call_merge",
	"call_missed_outgoing",
	"call_missed",
	"call_received",
	"call_split",
	"call",
	"call_to_action",
	"camera_alt",
	"camera_enhance",
	"camera_front",
	"camera_indoor",
	"camera_outdoor",
	"camera_rear",
	"camera_roll",
	"camera",
	"cameraswitch",
	"campaign",
	"cancel_presentation",
	"cancel_schedule_send",
	"cancel",
	"card_giftcard",
	"card_membership",
	"card_travel",
	"carpenter",
	"car_rental",
	"car_repair",
	"cases",
	"casino",
	"cast_connected",
	"cast_for_education",
	"cast",
	"catching_pokemon",
	"category",
	"celebration",
	"cell_wifi",
	"center_focus_strong",
	"center_focus_weak",
	"chair_alt",
	"chair",
	"chalet",
	"change_circle",
	"change_history",
	"charging_station",
	"chat_bubble_outline",
	"chat_bubble",
	"chat",
	"check_box_outline_blank",
	"check_box",
	"check_circle_outline",
	"check_circle",
	"checklist_rtl",
	"checklist",
	"checkroom",
	"check",
	"chevron_left",
	"chevron_right",
	"child_care",
	"child_friendly",
	"chrome_reader_mode",
	"circle_notifications",
	"circle",
	"class",
	"clean_hands",
	"cleaning_services",
	"clear_all",
	"clear",
	"closed_caption_disabled",
	"closed_caption_off",
	"closed_caption",
	"close_fullscreen",
	"close",
	"cloud_circle",
	"cloud_done",
	"cloud_download",
	"cloud_off",
	"cloud_queue",
	"cloud",
	"cloud_upload",
	"code_off",
	"code",
	"coffee_maker",
	"coffee",
	"collections_bookmark",
	"collections",
	"colorize",
	"color_lens",
	"comment_bank",
	"comment",
	"commute",
	"compare_arrows",
	"compare",
	"compass_calibration",
	"compost",
	"compress",
	"computer",
	"confirmation_number",
	"connected_tv",
	"connect_without_contact",
	"construction",
	"contactless",
	"contact_mail",
	"contact_page",
	"contact_phone",
	"contacts",
	"contact_support",
	"content_copy",
	"content_cut",
	"content_paste_off",
	"content_paste",
	"control_camera",
	"control_point_duplicate",
	"control_point",
	"copy_all",
	"copyright",
	"coronavirus",
	"corporate_fare",
	"cottage",
	"countertops",
	"create_new_folder",
	"create",
	"credit_card_off",
	"credit_card",
	"credit_score",
	"crib",
	"crop_16_9",
	"crop_3_2",
	"crop_5_4",
	"crop_7_5",
	"crop_din",
	"crop_free",
	"crop_landscape",
	"crop_original",
	"crop_portrait",
	"crop_rotate",
	"crop_square",
	"crop",
	"cruelty_free",
	"dangerous",
	"dark_mode",
	"dashboard_customize",
	"dashboard",
	"data_exploration",
	"data_saver_off",
	"data_saver_on",
	"data_usage",
	"date_range",
	"deck",
	"dehaze",
	"delete_forever",
	"delete_outline",
	"delete",
	"delete_sweep",
	"delivery_dining",
	"departure_board",
	"description",
	"design_services",
	"desktop_access_disabled",
	"desktop_mac",
	"desktop_windows",
	"details",
	"developer_board_off",
	"developer_board",
	"developer_mode",
	"device_hub",
	"devices_other",
	"devices",
	"device_thermostat",
	"device_unknown",
	"dialer_sip",
	"dialpad",
	"dining",
	"dinner_dining",
	"directions_bike",
	"directions_boat_filled",
	"directions_boat",
	"directions_bus_filled",
	"directions_bus",
	"directions_car_filled",
	"directions_car",
	"directions_off",
	"directions_railway_filled",
	"directions_railway",
	"directions_run",
	"directions_subway_filled",
	"directions_subway",
	"directions",
	"directions_transit_filled",
	"directions_transit",
	"directions_walk",
	"dirty_lens",
	"disabled_by_default",
	"disabled_visible",
	"disc_full",
	"dns",
	"dock",
	"document_scanner",
	"do_disturb_alt",
	"do_disturb_off",
	"do_disturb_on",
	"do_disturb",
	"domain_disabled",
	"domain",
	"domain_verification",
	"done_all",
	"done_outline",
	"done",
	"do_not_disturb_alt",
	"do_not_disturb_off",
	"do_not_disturb_on",
	"do_not_disturb_on_total_silence",
	"do_not_disturb",
	"do_not_step",
	"do_not_touch",
	"donut_large",
	"donut_small",
	"door_back",
	"doorbell",
	"door_front",
	"door_sliding",
	"double_arrow",
	"downhill_skiing",
	"download_done",
	"download_for_offline",
	"downloading",
	"download",
	"drafts",
	"drag_handle",
	"drag_indicator",
	"draw",
	"drive_eta",
	"drive_file_move_outline",
	"drive_file_move_rtl",
	"drive_file_move",
	"drive_file_rename_outline",
	"drive_folder_upload",
	"dry_cleaning",
	"dry",
	"duo",
	"dvr",
	"dynamic_feed",
	"dynamic_form",
	"earbuds_battery",
	"earbuds",
	"east",
	"eco",
	"edgesensor_high",
	"edgesensor_low",
	"edit_attributes",
	"edit_calendar",
	"edit_location_alt",
	"edit_location",
	"edit_note",
	"edit_notifications",
	"edit_off",
	"edit_road",
	"edit",
	"eject",
	"elderly",
	"electrical_services",
	"electric_bike",
	"electric_car",
	"electric_moped",
	"electric_rickshaw",
	"electric_scooter",
	"elevator",
	"email",
	"emergency",
	"e_mobiledata",
	"emoji_emotions",
	"emoji_events",
	"emoji_flags",
	"emoji_food_beverage",
	"emoji_nature",
	"emoji_objects",
	"emoji_people",
	"emoji_symbols",
	"emoji_transportation",
	"engineering",
	"enhanced_encryption",
	"equalizer",
	"error_outline",
	"error",
	"escalator",
	"escalator_warning",
	"euro",
	"euro_symbol",
	"event_available",
	"event_busy",
	"event_note",
	"event_seat",
	"event",
	"ev_station",
	"exit_to_app",
	"expand_less",
	"expand_more",
	"expand",
	"explicit",
	"explore_off",
	"explore",
	"exposure_neg_1",
	"exposure_neg_2",
	"exposure_plus_1",
	"exposure_plus_2",
	"exposure",
	"exposure_zero",
	"extension_off",
	"extension",
	"facebook",
	"face_retouching_natural",
	"face_retouching_off",
	"face",
	"face_unlock",
	"fact_check",
	"family_restroom",
	"fastfood",
	"fast_forward",
	"fast_rewind",
	"favorite_border",
	"favorite",
	"featured_play_list",
	"featured_video",
	"feedback",
	"feed",
	"female",
	"fence",
	"festival",
	"fiber_dvr",
	"fiber_manual_record",
	"fiber_new",
	"fiber_pin",
	"fiber_smart_record",
	"file_copy",
	"file_download_done",
	"file_download_off",
	"file_download",
	"file_present",
	"file_upload",
	"filter_1",
	"filter_2",
	"filter_3",
	"filter_4",
	"filter_5",
	"filter_6",
	"filter_7",
	"filter_8",
	"filter_9_plus",
	"filter_9",
	"filter_alt",
	"filter_b_and_w",
	"filter_center_focus",
	"filter_drama",
	"filter_frames",
	"filter_hdr",
	"filter_list_alt",
	"filter_list",
	"filter_none",
	"filter",
	"filter_tilt_shift",
	"filter_vintage",
	"find_in_page",
	"find_replace",
	"fingerprint",
	"fire_extinguisher",
	"fireplace",
	"first_page",
	"fitness_center",
	"fit_screen",
	"flag",
	"flaky",
	"flare",
	"flash_auto",
	"flashlight_off",
	"flashlight_on",
	"flash_off",
	"flash_on",
	"flatware",
	"flight_land",
	"flight",
	"flight_takeoff",
	"flip_camera_android",
	"flip_camera_ios",
	"flip",
	"flip_to_back",
	"flip_to_front",
	"flourescent",
	"flutter_dash",
	"fmd_bad",
	"fmd_good",
	"folder_open",
	"folder_shared",
	"folder_special",
	"folder",
	"follow_the_signs",
	"font_download_off",
	"font_download",
	"food_bank",
	"format_align_center",
	"format_align_justify",
	"format_align_left",
	"format_align_right",
	"format_bold",
	"format_clear",
	"format_color_fill",
	"format_color_reset",
	"format_color_text",
	"format_indent_decrease",
	"format_indent_increase",
	"format_italic",
	"format_line_spacing",
	"format_list_bulleted",
	"format_list_numbered_rtl",
	"format_list_numbered",
	"format_paint",
	"format_quote",
	"format_shapes",
	"format_size",
	"format_strikethrough",
	"format_textdirection_l_to_r",
	"format_textdirection_r_to_l",
	"format_underlined",
	"forum",
	"forward_10",
	"forward_30",
	"forward_5",
	"forward",
	"forward_to_inbox",
	"foundation",
	"free_breakfast",
	"free_cancellation",
	"front_hand",
	"fullscreen_exit",
	"fullscreen",
	"functions",
	"gamepad",
	"games",
	"garage",
	"gavel",
	"generating_tokens",
	"gesture",
	"get_app",
	"gif",
	"gite",
	"g_mobiledata",
	"golf_course",
	"gpp_bad",
	"gpp_good",
	"gpp_maybe",
	"gps_fixed",
	"gps_not_fixed",
	"gps_off",
	"grade",
	"gradient",
	"grading",
	"grain",
	"graphic_eq",
	"grass",
	"grid_3x3",
	"grid_4x4",
	"grid_goldenratio",
	"grid_off",
	"grid_on",
	"grid_view",
	"group_add",
	"group_off",
	"groups",
	"group",
	"group_work",
	"g_translate",
	"hail",
	"handyman",
	"hardware",
	"hdr_auto_select",
	"hdr_auto",
	"hdr_enhanced_select",
	"hdr_off_select",
	"hdr_off",
	"hdr_on_select",
	"hdr_on",
	"hdr_plus",
	"hdr_strong",
	"hdr_weak",
	"hd",
	"headphones_battery",
	"headphones",
	"headset_mic",
	"headset_off",
	"headset",
	"healing",
	"health_and_safety",
	"hearing_disabled",
	"hearing",
	"height",
	"help_center",
	"help_outline",
	"help",
	"hevc",
	"hide_image",
	"hide_source",
	"highlight_alt",
	"highlight_off",
	"highlight",
	"high_quality",
	"hiking",
	"history_edu",
	"history",
	"history_toggle_off",
	"h_mobiledata",
	"holiday_village",
	"home_filled",
	"home_max",
	"home_mini",
	"home_repair_service",
	"home",
	"home_work",
	"horizontal_distribute",
	"horizontal_rule",
	"horizontal_split",
	"hotel_class",
	"hotel",
	"hot_tub",
	"hourglass_bottom",
	"hourglass_disabled",
	"hourglass_empty",
	"hourglass_full",
	"hourglass_top",
	"houseboat",
	"house_siding",
	"house",
	"how_to_reg",
	"how_to_vote",
	"h_plus_mobiledata",
	"https",
	"http",
	"hvac",
	"icecream",
	"ice_skating",
	"icons-list.json",
	"image_aspect_ratio",
	"image_not_supported",
	"imagesearch_roller",
	"image_search",
	"image",
	"important_devices",
	"import_contacts",
	"import_export",
	"inbox",
	"incomplete_circle",
	"indeterminate_check_box",
	"info_outline",
	"info",
	"input",
	"insert_chart_outlined",
	"insert_chart",
	"insert_comment",
	"insert_drive_file",
	"insert_emoticon",
	"insert_invitation",
	"insert_link",
	"insert_photo",
	"insights",
	"integration_instructions",
	"inventory_2",
	"inventory",
	"invert_colors_off",
	"invert_colors",
	"ios_share",
	"iron",
	"iso",
	"kayaking",
	"keyboard_alt",
	"keyboard_arrow_down",
	"keyboard_arrow_left",
	"keyboard_arrow_right",
	"keyboard_arrow_up",
	"keyboard_backspace",
	"keyboard_capslock",
	"keyboard_hide",
	"keyboard_return",
	"keyboard",
	"keyboard_tab",
	"keyboard_voice",
	"king_bed",
	"kitchen",
	"kitesurfing",
	"label_important_outline",
	"label_important",
	"label_off",
	"label_outline",
	"label",
	"landscape",
	"language",
	"laptop_chromebook",
	"laptop_mac",
	"laptop",
	"laptop_windows",
	"last_page",
	"launch",
	"layers_clear",
	"layers",
	"leaderboard",
	"leak_add",
	"leak_remove",
	"legend_toggle",
	"lens_blur",
	"lens",
	"library_add_check",
	"library_add",
	"library_books",
	"library_music",
	"lightbulb_outline",
	"lightbulb",
	"light_mode",
	"light",
	"linear_scale",
	"line_style",
	"line_weight",
	"linked_camera",
	"link_off",
	"link",
	"liquor",
	"list_alt",
	"list",
	"live_help",
	"live_tv",
	"living",
	"local_activity",
	"local_airport",
	"local_atm",
	"local_bar",
	"local_cafe",
	"local_car_wash",
	"local_convenience_store",
	"local_dining",
	"local_drink",
	"local_fire_department",
	"local_florist",
	"local_gas_station",
	"local_grocery_store",
	"local_hospital",
	"local_hotel",
	"local_laundry_service",
	"local_library",
	"local_mall",
	"local_movies",
	"local_offer",
	"local_parking",
	"local_pharmacy",
	"local_phone",
	"local_pizza",
	"local_play",
	"local_police",
	"local_post_office",
	"local_printshop",
	"local_see",
	"local_shipping",
	"local_taxi",
	"location_city",
	"location_disabled",
	"location_off",
	"location_on",
	"location_pin",
	"location_searching",
	"lock_clock",
	"lock_open",
	"lock_outline",
	"lock",
	"login",
	"logout",
	"looks_3",
	"looks_4",
	"looks_5",
	"looks_6",
	"looks_one",
	"looks",
	"looks_two",
	"loop",
	"loupe",
	"low_priority",
	"loyalty",
	"lte_mobiledata",
	"lte_plus_mobiledata",
	"luggage",
	"lunch_dining",
	"mail_outline",
	"mail",
	"male",
	"manage_accounts",
	"manage_search",
	"maps_home_work",
	"maps_ugc",
	"map",
	"margin",
	"mark_as_unread",
	"mark_chat_read",
	"mark_chat_unread",
	"mark_email_read",
	"mark_email_unread",
	"markunread_mailbox",
	"markunread",
	"masks",
	"maximize",
	"media_bluetooth_off",
	"media_bluetooth_on",
	"mediation",
	"medical_services",
	"medication",
	"meeting_room",
	"memory",
	"menu_book",
	"menu_open",
	"menu",
	"merge_type",
	"message",
	"mic_external_off",
	"mic_external_on",
	"mic_none",
	"mic_off",
	"microwave",
	"mic",
	"military_tech",
	"minimize",
	"miscellaneous_services",
	"missed_video_call",
	"mms",
	"mobiledata_off",
	"mobile_friendly",
	"mobile_off",
	"mobile_screen_share",
	"mode_comment",
	"mode_edit_outline",
	"mode_edit",
	"model_training",
	"mode_night",
	"mode_standby",
	"mode",
	"monetization_on",
	"money_off_csred",
	"money_off",
	"money",
	"monitor",
	"monitor_weight",
	"monochrome_photos",
	"mood_bad",
	"mood",
	"moped",
	"more_horiz",
	"more",
	"more_time",
	"more_vert",
	"motion_photos_auto",
	"motion_photos_off",
	"motion_photos_on",
	"motion_photos_paused",
	"motion_photos_pause",
	"mouse",
	"move_to_inbox",
	"movie_creation",
	"movie_filter",
	"movie",
	"moving",
	"mp",
	"multiline_chart",
	"multiple_stop",
	"museum",
	"music_note",
	"music_off",
	"music_video",
	"my_location",
	"nat",
	"nature_people",
	"nature",
	"navigate_before",
	"navigate_next",
	"navigation",
	"nearby_error",
	"nearby_off",
	"near_me_disabled",
	"near_me",
	"network_cell",
	"network_check",
	"network_locked",
	"network_wifi",
	"new_label",
	"new_releases",
	"next_plan",
	"next_week",
	"nfc",
	"nightlife",
	"nightlight_round",
	"nightlight",
	"night_shelter",
	"nights_stay",
	"no_accounts",
	"no_backpack",
	"no_cell",
	"no_drinks",
	"no_encryption_gmailerrorred",
	"no_encryption",
	"no_flash",
	"no_food",
	"no_luggage",
	"no_meals_ouline",
	"no_meals",
	"no_meeting_room",
	"no_photography",
	"nordic_walking",
	"north_east",
	"north",
	"north_west",
	"no_sim",
	"no_stroller",
	"not_accessible",
	"note_add",
	"note_alt",
	"notes",
	"note",
	"notification_add",
	"notification_important",
	"notifications_active",
	"notifications_none",
	"notifications_off",
	"notifications_paused",
	"notifications",
	"not_interested",
	"not_listed_location",
	"no_transfer",
	"not_started",
	"offline_bolt",
	"offline_pin",
	"offline_share",
	"ondemand_video",
	"online_prediction",
	"opacity",
	"open_in_browser",
	"open_in_full",
	"open_in_new_off",
	"open_in_new",
	"open_with",
	"other_houses",
	"outbond",
	"outbound",
	"outbox",
	"outdoor_grill",
	"outgoing_mail",
	"outlet",
	"outlined_flag",
	"padding",
	"pages",
	"pageview",
	"paid",
	"palette",
	"panorama_fish_eye",
	"panorama_horizontal_select",
	"panorama_horizontal",
	"panorama_photosphere_select",
	"panorama_photosphere",
	"panorama",
	"panorama_vertical_select",
	"panorama_vertical",
	"panorama_wide_angle_select",
	"panorama_wide_angle",
	"pan_tool",
	"paragliding",
	"park",
	"party_mode",
	"password",
	"pattern",
	"pause_circle_filled",
	"pause_circle_outline",
	"pause_circle",
	"pause_presentation",
	"pause",
	"payments",
	"payment",
	"pedal_bike",
	"pending_actions",
	"pending",
	"people_alt",
	"people_outline",
	"people",
	"perm_camera_mic",
	"perm_contact_calendar",
	"perm_data_setting",
	"perm_device_information",
	"perm_identity",
	"perm_media",
	"perm_phone_msg",
	"perm_scan_wifi",
	"person_add_alt_1",
	"person_add_alt",
	"person_add_disabled",
	"person_add",
	"personal_injury",
	"personal_video",
	"person_off",
	"person_outline",
	"person_pin_circle",
	"person_pin",
	"person_remove_alt_1",
	"person_remove",
	"person_search",
	"person",
	"pest_control_rodent",
	"pest_control",
	"pets",
	"phone_android",
	"phone_bluetooth_speaker",
	"phone_callback",
	"phone_disabled",
	"phone_enabled",
	"phone_forwarded",
	"phone_in_talk",
	"phone_iphone",
	"phonelink_erase",
	"phonelink_lock",
	"phonelink_off",
	"phonelink_ring",
	"phonelink_setup",
	"phonelink",
	"phone_locked",
	"phone_missed",
	"phone_paused",
	"phone",
	"photo_album",
	"photo_camera_back",
	"photo_camera_front",
	"photo_camera",
	"photo_filter",
	"photo_library",
	"photo_size_select_actual",
	"photo_size_select_large",
	"photo_size_select_small",
	"photo",
	"piano_off",
	"piano",
	"picture_as_pdf",
	"picture_in_picture_alt",
	"picture_in_picture",
	"pie_chart_outlined",
	"pie_chart_outline",
	"pie_chart",
	"pin_drop",
	"pin_end",
	"pin_invoke",
	"pin",
	"pivot_table_chart",
	"place",
	"plagiarism",
	"play_arrow",
	"play_circle_filled",
	"play_circle_outline",
	"play_circle",
	"play_disabled",
	"play_for_work",
	"play_lesson",
	"playlist_add_check",
	"playlist_add",
	"playlist_play",
	"plumbing",
	"plus_one",
	"podcasts",
	"point_of_sale",
	"policy",
	"poll",
	"polymer",
	"pool",
	"portable_wifi_off",
	"portrait",
	"post_add",
	"power_input",
	"power_off",
	"power_settings_new",
	"power",
	"precision_manufacturing",
	"pregnant_woman",
	"present_to_all",
	"preview",
	"price_change",
	"price_check",
	"print_disabled",
	"print",
	"priority_high",
	"privacy_tip",
	"private_connectivity",
	"production_quantity_limits",
	"psychology",
	"public_off",
	"public",
	"published_with_changes",
	"publish",
	"push_pin",
	"qr_code_2",
	"qr_code_scanner",
	"qr_code",
	"query_builder",
	"query_stats",
	"question_answer",
	"queue_music",
	"queue_play_next",
	"queue",
	"quickreply",
	"quiz",
	"radar",
	"radio_button_checked",
	"radio_button_unchecked",
	"radio",
	"railway_alert",
	"ramen_dining",
	"rate_review",
	"raw_off",
	"raw_on",
	"read_more",
	"real_estate_agent",
	"receipt_long",
	"receipt",
	"recent_actors",
	"recommend",
	"record_voice_over",
	"recycling",
	"redeem",
	"redo",
	"reduce_capacity",
	"refresh",
	"remember_me",
	"remove_circle_outline",
	"remove_circle",
	"remove_done",
	"remove_from_queue",
	"remove_moderator",
	"remove_red_eye",
	"remove_shopping_cart",
	"remove",
	"reorder",
	"repeat_one_on",
	"repeat_one",
	"repeat_on",
	"repeat",
	"replay_10",
	"replay_30",
	"replay_5",
	"replay_circle_filled",
	"replay",
	"reply_all",
	"reply",
	"report_gmailerrorred",
	"report_off",
	"report_problem",
	"report",
	"request_page",
	"request_quote",
	"reset_tv",
	"restart_alt",
	"restaurant_menu",
	"restaurant",
	"restore_from_trash",
	"restore_page",
	"restore",
	"reviews",
	"rice_bowl",
	"ring_volume",
	"r_mobiledata",
	"roofing",
	"room_preferences",
	"room_service",
	"room",
	"rotate_90_degrees_ccw",
	"rotate_left",
	"rotate_right",
	"rounded_corner",
	"router",
	"rowing",
	"rss_feed",
	"rsvp",
	"rtt",
	"rule_folder",
	"rule",
	"run_circle",
	"running_with_errors",
	"rv_hookup",
	"safety_divider",
	"sailing",
	"sanitizer",
	"satellite",
	"save_alt",
	"saved_search",
	"save",
	"savings",
	"scanner",
	"scatter_plot",
	"schedule_send",
	"schedule",
	"schema",
	"school",
	"science",
	"score",
	"screen_lock_landscape",
	"screen_lock_portrait",
	"screen_lock_rotation",
	"screen_rotation",
	"screen_search_desktop",
	"screen_share",
	"screenshot",
	"sd_card_alert",
	"sd_card",
	"sd_storage",
	"sd",
	"search_off",
	"search",
	"security",
	"security_update_good",
	"security_update",
	"security_update_warning",
	"segment",
	"select_all",
	"self_improvement",
	"sell",
	"send_and_archive",
	"send",
	"send_to_mobile",
	"sensor_door",
	"sensors_off",
	"sensors",
	"sensor_window",
	"sentiment_dissatisfied",
	"sentiment_neutral",
	"sentiment_satisfied_alt",
	"sentiment_satisfied",
	"sentiment_very_dissatisfied",
	"sentiment_very_satisfied",
	"set_meal",
	"settings_accessibility",
	"settings_applications",
	"settings_backup_restore",
	"settings_bluetooth",
	"settings_brightness",
	"settings_cell",
	"settings_ethernet",
	"settings_input_antenna",
	"settings_input_component",
	"settings_input_composite",
	"settings_input_hdmi",
	"settings_input_svideo",
	"settings_overscan",
	"settings_phone",
	"settings_power",
	"settings_remote",
	"settings_suggest",
	"settings",
	"settings_system_daydream",
	"settings_voice",
	"share_location",
	"share",
	"shield",
	"shop_2",
	"shopping_bag",
	"shopping_basket",
	"shopping_cart",
	"shop",
	"shop_two",
	"shortcut",
	"short_text",
	"show_chart",
	"shower",
	"shuffle_on",
	"shuffle",
	"shutter_speed",
	"sick",
	"signal_cellular_0_bar",
	"signal_cellular_4_bar",
	"signal_cellular_alt",
	"signal_cellular_connected_no_internet_0_bar",
	"signal_cellular_connected_no_internet_4_bar",
	"signal_cellular_nodata",
	"signal_cellular_no_sim",
	"signal_cellular_null",
	"signal_cellular_off",
	"signal_wifi_0_bar",
	"signal_wifi_4_bar_lock",
	"signal_wifi_4_bar",
	"signal_wifi_bad",
	"signal_wifi_connected_no_internet_4",
	"signal_wifi_off",
	"signal_wifi_statusbar_4_bar",
	"signal_wifi_statusbar_connected_no_internet_4",
	"signal_wifi_statusbar_null",
	"sim_card_alert",
	"sim_card_download",
	"sim_card",
	"single_bed",
	"sip",
	"skateboarding",
	"skip_next",
	"skip_previous",
	"sledding",
	"slideshow",
	"slow_motion_video",
	"smart_button",
	"smart_display",
	"smartphone",
	"smart_screen",
	"smart_toy",
	"smoke_free",
	"smoking_rooms",
	"sms_failed",
	"sms",
	"snippet_folder",
	"snooze",
	"snowboarding",
	"snowmobile",
	"snowshoeing",
	"soap",
	"social_distance",
	"sort_by_alpha",
	"sort",
	"source",
	"south_east",
	"south",
	"south_west",
	"space_bar",
	"space_dashboard",
	"spa",
	"speaker_group",
	"speaker_notes_off",
	"speaker_notes",
	"speaker_phone",
	"speaker",
	"speed",
	"spellcheck",
	"splitscreen",
	"sports_bar",
	"sports_baseball",
	"sports_basketball",
	"sports_cricket",
	"sports_esports",
	"sports_football",
	"sports_golf",
	"sports_handball",
	"sports_hockey",
	"sports_kabaddi",
	"sports_mma",
	"sports_motorsports",
	"sports_rugby",
	"sports_score",
	"sports_soccer",
	"sports",
	"sports_tennis",
	"sports_volleyball",
	"square_foot",
	"stacked_bar_chart",
	"stacked_line_chart",
	"stairs",
	"star_border_purple500",
	"star_border",
	"star_half",
	"star_outline",
	"star_purple500",
	"star_rate",
	"stars",
	"star",
	"stay_current_landscape",
	"stay_current_portrait",
	"stay_primary_landscape",
	"stay_primary_portrait",
	"sticky_note_2",
	"stop_circle",
	"stop_screen_share",
	"stop",
	"storage",
	"storefront",
	"store_mall_directory",
	"store",
	"storm",
	"straighten",
	"stream",
	"streetview",
	"strikethrough_s",
	"stroller",
	"style",
	"subdirectory_arrow_left",
	"subdirectory_arrow_right",
	"subject",
	"subscriptions",
	"subscript",
	"subtitles_off",
	"subtitles",
	"subway",
	"summarize",
	"superscript",
	"supervised_user_circle",
	"supervisor_account",
	"support_agent",
	"support",
	"surfing",
	"surround_sound",
	"swap_calls",
	"swap_horizontal_circle",
	"swap_horiz",
	"swap_vertical_circle",
	"swap_vert",
	"swipe",
	"switch_account",
	"switch_camera",
	"switch_left",
	"switch_right",
	"switch_video",
	"sync_alt",
	"sync_disabled",
	"sync_problem",
	"sync",
	"system_security_update_good",
	"system_security_update",
	"system_security_update_warning",
	"system_update_alt",
	"system_update",
	"table_chart",
	"table_rows",
	"tablet_android",
	"tablet_mac",
	"tablet",
	"table_view",
	"tab",
	"tab_unselected",
	"tag_faces",
	"tag",
	"takeout_dining",
	"tap_and_play",
	"tapas",
	"task_alt",
	"task",
	"taxi_alert",
	"terrain",
	"text_fields",
	"text_format",
	"text_rotate_up",
	"text_rotate_vertical",
	"text_rotation_angledown",
	"text_rotation_angleup",
	"text_rotation_down",
	"text_rotation_none",
	"textsms",
	"text_snippet",
	"texture",
	"theater_comedy",
	"theaters",
	"thermostat_auto",
	"thermostat",
	"thumb_down_alt",
	"thumb_down_off_alt",
	"thumb_down",
	"thumbs_up_down",
	"thumb_up_alt",
	"thumb_up_off_alt",
	"thumb_up",
	"timelapse",
	"timeline",
	"timer_10_select",
	"timer_10",
	"timer_3_select",
	"timer_3",
	"timer_off",
	"timer",
	"time_to_leave",
	"tips_and_updates",
	"title",
	"toc",
	"today",
	"toggle_off",
	"toggle_on",
	"toll",
	"tonality",
	"topic",
	"touch_app",
	"tour",
	"toys",
	"track_changes",
	"traffic",
	"train",
	"tram",
	"transfer_within_a_station",
	"transform",
	"transgender",
	"transit_enterexit",
	"translate",
	"travel_explore",
	"trending_down",
	"trending_flat",
	"trending_up",
	"trip_origin",
	"try",
	"tty",
	"tune",
	"tungsten",
	"turned_in_not",
	"turned_in",
	"tv_off",
	"tv",
	"two_wheeler",
	"umbrella",
	"unarchive",
	"undo",
	"unfold_less",
	"unfold_more",
	"unpublished",
	"unsubscribe",
	"upcoming",
	"update_disabled",
	"update",
	"upgrade",
	"upload_file",
	"upload",
	"usb_off",
	"usb",
	"verified",
	"verified_user",
	"vertical_align_bottom",
	"vertical_align_center",
	"vertical_align_top",
	"vertical_distribute",
	"vertical_split",
	"vibration",
	"video_call",
	"video_camera_back",
	"video_camera_front",
	"videocam_off",
	"videocam",
	"videogame_asset_off",
	"videogame_asset",
	"video_label",
	"video_library",
	"video_settings",
	"video_stable",
	"view_agenda",
	"view_array",
	"view_carousel",
	"view_column",
	"view_comfy",
	"view_compact",
	"view_day",
	"view_headline",
	"view_in_ar",
	"view_list",
	"view_module",
	"view_quilt",
	"view_sidebar",
	"view_stream",
	"view_week",
	"vignette",
	"villa",
	"visibility_off",
	"visibility",
	"voice_chat",
	"voicemail",
	"voice_over_off",
	"volume_down_alt",
	"volume_down",
	"volume_mute",
	"volume_off",
	"volume_up",
	"volunteer_activism",
	"vpn_key",
	"vpn_lock",
	"vrpano",
	"wallpaper",
	"warning_amber",
	"warning",
	"wash",
	"watch_later",
	"watch",
	"water_damage",
	"water_drop",
	"waterfall_chart",
	"water",
	"waves",
	"waving_hand",
	"wb_auto",
	"wb_cloudy",
	"wb_incandescent",
	"wb_iridescent",
	"wb_shade",
	"wb_sunny",
	"wb_twighlight",
	"wb_twilight",
	"wc",
	"web_asset_off",
	"web_asset",
	"web_stories",
	"web",
	"weekend",
	"west",
	"whatshot",
	"wheelchair_pickup",
	"where_to_vote",
	"widgets",
	"wifi_calling_3",
	"wifi_calling",
	"wifi_lock",
	"wifi_off",
	"wifi_protected_setup",
	"wifi",
	"wifi_tethering_error_rounded",
	"wifi_tethering_off",
	"wifi_tethering",
	"window",
	"wine_bar",
	"work_off",
	"work_outline",
	"workspaces_filled",
	"workspaces_outline",
	"workspaces",
	"work",
	"wrap_text",
	"wrong_location",
	"wysiwyg",
	"yard",
	"youtube_searched_for",
	"zoom_in",
	"zoom_out_map",
	"zoom_out"
];
var matIcons = {
	icons: icons
};

const BACKTORY_MAT_ICONS_FOLDER = 'https://cdn.tapsell.ir/front-ch/material-icons';

class PghIconRegisterService {
    constructor(matIconRegistry, httpClient, domSanitizer) {
        this.matIconRegistry = matIconRegistry;
        this.httpClient = httpClient;
        this.domSanitizer = domSanitizer;
        this.registerIcons();
    }
    registerIcons() {
        matIcons.icons.forEach(icon => {
            this.loadIcon(icon);
        });
    }
    loadIcon(iconKey, iconUrl = BACKTORY_MAT_ICONS_FOLDER) {
        this.matIconRegistry.addSvgIcon(iconKey, this.domSanitizer.bypassSecurityTrustResourceUrl(`${iconUrl}/${iconKey}.svg`));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: PghIconRegisterService, deps: [{ token: i1.MatIconRegistry }, { token: i2.HttpClient }, { token: i3.DomSanitizer }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: PghIconRegisterService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: PghIconRegisterService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: i1.MatIconRegistry }, { type: i2.HttpClient }, { type: i3.DomSanitizer }] });

/**
 * Generated bundle index. Do not edit.
 */

export { PghIconRegisterService };
//# sourceMappingURL=tapsellorg-angular-material-library-src-lib-icon-svg.mjs.map
