import * as i0 from '@angular/core';
import { input, signal, ContentChild, ChangeDetectionStrategy, ViewEncapsulation, Component, NgModule } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@angular/cdk/overlay';
import { OverlayModule } from '@angular/cdk/overlay';

class PghOverlayComponent {
    constructor(cdr) {
        this.cdr = cdr;
        this.origin = input.required();
        this.panelClasses = input([]);
        this.isOpen = signal(false);
    }
    close() {
        this.isOpen.set(false);
        this.cdr.detectChanges();
    }
    open() {
        this.isOpen.set(true);
        this.cdr.detectChanges();
    }
    getOverlayPanelClasses() {
        return ['pgh-overlay', ...this.panelClasses()];
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: PghOverlayComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.2.13", type: PghOverlayComponent, isStandalone: false, selector: "pgh-overlay", inputs: { origin: { classPropertyName: "origin", publicName: "origin", isSignal: true, isRequired: true, transformFunction: null }, panelClasses: { classPropertyName: "panelClasses", publicName: "panelClasses", isSignal: true, isRequired: false, transformFunction: null } }, queries: [{ propertyName: "overlayContent", first: true, predicate: ["pghOverlayContent"], descendants: true }], exportAs: ["pghOverlay"], ngImport: i0, template: "<ng-template\n  cdkConnectedOverlay\n  [cdkConnectedOverlayOrigin]=\"origin()\"\n  [cdkConnectedOverlayOpen]=\"isOpen()\"\n  [cdkConnectedOverlayPanelClass]=\"getOverlayPanelClasses()\"\n  [cdkConnectedOverlayHasBackdrop]=\"true\"\n  [cdkConnectedOverlayBackdropClass]=\"'cdk-overlay-transparent-backdrop'\"\n  (backdropClick)=\"close()\"\n>\n  <ng-content></ng-content>\n  <ng-container *ngTemplateOutlet=\"overlayContent || null\"></ng-container>\n</ng-template>\n", styles: [".pgh-overlay{display:block!important;padding:1rem;background:var(--fff);border-radius:var(--box-radius);box-shadow:var(--shadow-lg)}\n"], dependencies: [{ kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush", "cdkConnectedOverlayDisposeOnNavigation"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: PghOverlayComponent, decorators: [{
            type: Component,
            args: [{ selector: 'pgh-overlay', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, exportAs: 'pghOverlay', standalone: false, template: "<ng-template\n  cdkConnectedOverlay\n  [cdkConnectedOverlayOrigin]=\"origin()\"\n  [cdkConnectedOverlayOpen]=\"isOpen()\"\n  [cdkConnectedOverlayPanelClass]=\"getOverlayPanelClasses()\"\n  [cdkConnectedOverlayHasBackdrop]=\"true\"\n  [cdkConnectedOverlayBackdropClass]=\"'cdk-overlay-transparent-backdrop'\"\n  (backdropClick)=\"close()\"\n>\n  <ng-content></ng-content>\n  <ng-container *ngTemplateOutlet=\"overlayContent || null\"></ng-container>\n</ng-template>\n", styles: [".pgh-overlay{display:block!important;padding:1rem;background:var(--fff);border-radius:var(--box-radius);box-shadow:var(--shadow-lg)}\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }], propDecorators: { overlayContent: [{
                type: ContentChild,
                args: ['pghOverlayContent']
            }] } });

class PghOverlayModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: PghOverlayModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.13", ngImport: i0, type: PghOverlayModule, declarations: [PghOverlayComponent], imports: [CommonModule, OverlayModule], exports: [PghOverlayComponent, OverlayModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: PghOverlayModule, imports: [CommonModule, OverlayModule, OverlayModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: PghOverlayModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [PghOverlayComponent],
                    imports: [CommonModule, OverlayModule],
                    exports: [PghOverlayComponent, OverlayModule],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { PghOverlayComponent, PghOverlayModule };
//# sourceMappingURL=tapsellorg-angular-material-library-src-lib-overlay.mjs.map
