export { ArrayUtils, CacheInterceptor, FileUtils, MiscUtils, ObjectUtils, ObservedBy, Observing, PGH_CACHE_INTERCEPTOR_OPTIONS, PGH_ERROR_HANDLER_OPTIONS, PGH_MAT_GLOBAL_OPTIONS, PGH_PRODUCT_TITLE, PghArrayJoinModule, PghArrayJoinPipe, PghArraySplitModule, PghArraySplitPipe, PghAutomaticInnerOuterLinkDirective, PghAutomaticInnerOuterLinkModule, PghDarkModeService, PghEnumToArrayModule, PghEnumToArrayPipe, PghErrorHandlerInterceptor, PghErrorHandlerService, PghReplaceWithModule, PghSafeModule, PghSafePipe, PghShortNumberModule, PghShortNumberPipe, PghStorageFactory, PghTabTitleService, PghTrailingSlashInterceptor, StringUtils, UrlUtils, pghDebounceTime, withDestroy } from '@tapsellorg/angular-material-library/src/lib/common';
export { PghAnimations } from '@tapsellorg/angular-material-library/src/lib/animations';
export { DateUtils, GregorianJalaliHelper, JALALI_NAME_MONTH_FORMATS, JALALI_SLASH_FORMATS, JalaliDate, MaterialJalaliDateAdapter, PGH_MAT_PERSIAN_GLOBAL_OPTIONS, PghJalaliDateModule, PghJalaliDatePipe, PghPersianMatPaginatorIntl, localeIr } from '@tapsellorg/angular-material-library/src/lib/jalali-date-adapter';
export { PghHelpIndicatorComponent, PghHelpIndicatorModule } from '@tapsellorg/angular-material-library/src/lib/help-indicator';
export { PghStatsBoxComponent, PghStatsBoxModule } from '@tapsellorg/angular-material-library/src/lib/stats-box';
export { PghTableBoxComponent, PghTableDatasource, PghTableDateRangePickerDirective, PghTableHeaderDirective, PghTableModule } from '@tapsellorg/angular-material-library/src/lib/table';
export { PghLayoutComponent, PghLayoutModule, PghSidebarItemComponent } from '@tapsellorg/angular-material-library/src/lib/layout';
export { PGH_DEFAULT_PREDEFINED_DATE_RANGES, PGH_PREDEFINED_DATE_RANGES, PghDatePickerHeaderComponent, PghDatePickerService, PghDateRangePickerComponent, PghDateRangePickerControllerService, PghDateRangePickerModule, PghDateRangePickerSelectionStrategy, PghMaxRangeDirective, PghPredefinedRangeCalculator } from '@tapsellorg/angular-material-library/src/lib/date-range-picker';
export { PghDragDropFileComponent, PghDragDropModule, PghDropTargetDirective, PghFileInputComponent, PghFileInputModule } from '@tapsellorg/angular-material-library/src/lib/drag-drop';
export { PghLoader, PghLoaderDirective, PghLoaderModule, pghLoader } from '@tapsellorg/angular-material-library/src/lib/loader';
export { PghFormExpansionPanelComponent, PghFormExpansionPanelModule } from '@tapsellorg/angular-material-library/src/lib/form-expansion-panel';
export { PghSmoothHeightDirective, PghSmoothHeightModule } from '@tapsellorg/angular-material-library/src/lib/smooth-height';
export { PghLightboxComponent, PghLightboxDirective, PghLightboxModule } from '@tapsellorg/angular-material-library/src/lib/lightbox';
export { PghImageSliderComponent, PghImageSliderModule } from '@tapsellorg/angular-material-library/src/lib/image-slider';
export { PghFilterChipAutoCompleteComponent, PghFilterChipAutoCompleteModule, PghFilterChipInputComponent, PghFilterChipInputModule, PghFilterChipItemComponent, PghFilterChipMultiSelectComponent, PghFilterChipMultiSelectModule, PghFilterChipSelectComponent, PghFilterChipSelectModule, PghFilterChipsComponent, PghFilterChipsItem, PghFilterChipsMarkerDirective, PghFilterChipsModule, PghFilterChipsPersistService } from '@tapsellorg/angular-material-library/src/lib/filter-chips';
export { PghSelectAllOptionsDirective, PghSelectAllOptionsModule } from '@tapsellorg/angular-material-library/src/lib/select-all-options';
export { PGH_DEFAULT_ERROR_MESSAGES, PGH_FIELD_ERROR_MESSAGES, PghAutofocusDirective, PghAutofocusModule, PghFieldErrorDirective, PghFileValidators, PghFinancialInputDirective, PghFormValidators, PghInputModule, PghInputTypeDirective, PghMarkAllAsTouchedDirective, PghMoneyToWordsPipe, PghNumberToWordsPipe, PghNumberToWordsService, PghPersianNumbersToEnglishDirective, PghRialToTomanPipe } from '@tapsellorg/angular-material-library/src/lib/input';
export { PghHourRangePickerComponent, PghHourRangePickerDialogComponent, PghHourRangePickerModule, PghHoursRangeChipsComponent } from '@tapsellorg/angular-material-library/src/lib/hour-range-picker';
export { PghPageHeadComponent, PghPageHeadModule } from '@tapsellorg/angular-material-library/src/lib/page-head';
export { PghAuthLayoutComponent, PghAuthModule, PghCompleteUserDataComponent, PghForgetPasswordComponent, PghLoginComponent, PghLoginOtpComponent, PghRegisterComponent, PghVerificationCodeComponent } from '@tapsellorg/angular-material-library/src/lib/auth';
export { PghIconRegisterService } from '@tapsellorg/angular-material-library/src/lib/icon-svg';
export { PGH_STATUS_CONFIG, PghStatusLabelComponent, PghStatusLabelModule } from '@tapsellorg/angular-material-library/src/lib/status-label';
export { PghGravatarModule, PghGravatarPipe } from '@tapsellorg/angular-material-library/src/lib/gravatar';
export { PghAutoCompleteComponent, PghAutoCompleteModule } from '@tapsellorg/angular-material-library/src/lib/auto-complete';
export { PghOverlayComponent, PghOverlayModule } from '@tapsellorg/angular-material-library/src/lib/overlay';
export { PghCreativePreviewComponent, PghCreativePreviewModule } from '@tapsellorg/angular-material-library/src/lib/creative-preview';
export { PghRefreshButtonComponent, PghRefreshButtonModule } from '@tapsellorg/angular-material-library/src/lib/refresh-button';
export { PghCountdownTimerComponent, PghCountdownTimerModule, PghCountdownTimerService } from '@tapsellorg/angular-material-library/src/lib/countdown-timer';
import * as i0 from '@angular/core';
import { InjectionToken, Inject, Injectable, Pipe, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
export { PghDayHourPickerComponent, PghDayHourPickerModule } from '@tapsellorg/angular-material-library/src/lib/day-hour-picker';
export { PghTreeComponent, PghTreeModule } from '@tapsellorg/angular-material-library/src/lib/tree';
export { PghMessageCardComponent } from '@tapsellorg/angular-material-library/src/lib/message-card';

const PGH_LANGUAGE_CONFIG = new InjectionToken('language-config', {
    providedIn: 'root',
    factory: () => 'fa',
});

const conditionBuilderEnMessages = {
    CONDITION_BUILDER_RESET_BUTTON: 'Reset',
    CONDITION_BUILDER_DELETE_BUTTON: 'Delete',
    CONDITION_BUILDER_NEW_FILTER_BUTTON: 'New Filter',
    CONDITION_BUILDER_AND: 'AND',
    CONDITION_BUILDER_OR: 'OR',
    CONDITION_BUILDER_VALIDATION_HINT: "You can't add more filters unless your previous ones are all valid",
};
const dateRangePickerEnMessages = {
    DATE_RANGE_PICKER_FROM: 'from',
    DATE_RANGE_PICKER_TO: 'to',
    DATE_RANGE_PICKER_START_DATE: 'Start date',
    DATE_RANGE_PICKER_END_DATE: 'End date',
    DATE_RANGE_PICKER_TODAY: 'Today',
    DATE_RANGE_PICKER_YESTERDAY: 'Yesterday',
    DATE_RANGE_PICKER_LAST_THIRTY_DAYS: 'Last 30 days',
    DATE_RANGE_PICKER_LAST_SIXTY_DAYS: 'Last 60 days',
    DATE_RANGE_PICKER_LAST_SEVEN_DAYS: 'Last 7 days',
    DATE_RANGE_PICKER_CURRENT_MONTH: 'Current month',
    DATE_RANGE_PICKER_DELETE_BUTTON: 'Delete Date',
};
const filterChipsEnMessages = {
    FILTER_CHIPS_NEW_FILTER_BUTTON: 'New Filter',
    FILTER_CHIPS_SEARCH_BUTTON: 'Search',
    FILTER_CHIPS_SELECT_ALL_OPTIONS: 'All',
};
const ssoEnMessages = {
    SSO_SERVICES_SHORTCUT_TITLE: 'Services',
    SSO_USER_MENU_USER_PROFILE: 'User Profile',
    SSO_USER_MENU_DARK_MODE: 'Dark Mode',
    SSO_USER_MENU_LIGHT_MODE: 'Light Mode',
    SSO_USER_MENU_CHANGE_PASSWORD: 'Change Password',
    SSO_USER_MENU_LOGOUT: 'Logout',
    SSO_ADMIN_SERVICES_SHORTCUT_TITLE: 'Admin Panels',
};
const confirmDialogEnMessages = {
    CONFIRM_DIALOG_ACCEPT_BUTTON: 'Confirm',
    CONFIRM_DIALOG_REJECT_BUTTON: 'Reject',
    CONFIRM_DIALOG_DONT_SHOW_AGAIN_CHECKBOX: "Don't show this message again",
};
const accidentallyClosedEnMessage = {
    ACCIDENTALLY_CLOSED_TITLE: 'Unsaved Changes',
    ACCIDENTALLY_CLOSED_MESSAGE: 'Unsaved changes were detected. Are you sure you want to leave this page?',
    ACCIDENTALLY_CLOSED_REJECT_BUTTON: 'Stay',
    ACCIDENTALLY_CLOSED_ACCEPT_BUTTON: 'Leave',
};
const fullChartEnMessages = {
    FULL_CHART_PLACEHOLDER_TEXT: 'No data is available',
};
const dragAndDropEnMessages = {
    DRAG_AND_DROP_DELETE_BUTTON: 'Delete File',
    DRAG_AND_DROP_DOWNLOAD_BUTTON: 'Download File',
};
const notifEnMessages = {
    NOTIF_CLOSE_BUTTON: 'Close',
};
const countDownTimerEnMessage = {
    RESTART_BUTTON_TEXT: 'Start again',
    RESTART_BUTTON_TEXT_CONJUNCTION: 'Until',
};
const enMessages = {
    ...conditionBuilderEnMessages,
    ...dateRangePickerEnMessages,
    ...filterChipsEnMessages,
    ...ssoEnMessages,
    ...confirmDialogEnMessages,
    ...accidentallyClosedEnMessage,
    ...fullChartEnMessages,
    ...dragAndDropEnMessages,
    ...notifEnMessages,
    ...countDownTimerEnMessage,
};

const conditionBuilderFaMessages = {
    CONDITION_BUILDER_RESET_BUTTON: 'تنظیم مجدد',
    CONDITION_BUILDER_DELETE_BUTTON: 'حذف',
    CONDITION_BUILDER_NEW_FILTER_BUTTON: 'فیلتر جدید',
    CONDITION_BUILDER_AND: 'و',
    CONDITION_BUILDER_OR: 'یا',
    CONDITION_BUILDER_VALIDATION_HINT: 'تا زمانی که فیلتر های قبلی درست نباشند، نمی توانید فیلتر دیگری اضافه کنید',
};
const dateRangePickerFaMessages = {
    DATE_RANGE_PICKER_FROM: 'از',
    DATE_RANGE_PICKER_TO: 'تا',
    DATE_RANGE_PICKER_START_DATE: 'تاریخ شروع',
    DATE_RANGE_PICKER_END_DATE: 'تاریخ پایان',
    DATE_RANGE_PICKER_TODAY: 'امروز',
    DATE_RANGE_PICKER_YESTERDAY: 'دیروز',
    DATE_RANGE_PICKER_LAST_THIRTY_DAYS: 'سی روز اخیر',
    DATE_RANGE_PICKER_LAST_SIXTY_DAYS: 'شصت روز اخیر',
    DATE_RANGE_PICKER_LAST_SEVEN_DAYS: 'هفت روز اخیر',
    DATE_RANGE_PICKER_CURRENT_MONTH: 'این ماه',
    DATE_RANGE_PICKER_DELETE_BUTTON: 'حذف تاریخ',
};
const filterChipsFaMessages = {
    FILTER_CHIPS_NEW_FILTER_BUTTON: 'افزودن فیلتر',
    FILTER_CHIPS_SEARCH_BUTTON: 'جستجو',
    FILTER_CHIPS_SELECT_ALL_OPTIONS: 'همه',
};
const ssoFaMessages = {
    SSO_SERVICES_SHORTCUT_TITLE: 'سرویس‌ها',
    SSO_USER_MENU_USER_PROFILE: 'پروفایل کاربری',
    SSO_USER_MENU_DARK_MODE: 'حالت شب',
    SSO_USER_MENU_LIGHT_MODE: 'حالت روز',
    SSO_USER_MENU_CHANGE_PASSWORD: 'تغییر رمز عبور',
    SSO_USER_MENU_LOGOUT: 'خروج',
    SSO_ADMIN_SERVICES_SHORTCUT_TITLE: 'پنل های ادمین',
};
const confirmDialogFaMessages = {
    CONFIRM_DIALOG_ACCEPT_BUTTON: 'تایید',
    CONFIRM_DIALOG_REJECT_BUTTON: 'انصراف',
    CONFIRM_DIALOG_DONT_SHOW_AGAIN_CHECKBOX: 'دیگر این پیام را نمایش نده',
};
const accidentallyClosedFaMessage = {
    ACCIDENTALLY_CLOSED_TITLE: 'تغییرات ذخیره نشده',
    ACCIDENTALLY_CLOSED_MESSAGE: 'تغییرات اعمال شده ذخیره نشده است، آیا از ترک صفحه مطمئنید؟',
    ACCIDENTALLY_CLOSED_REJECT_BUTTON: 'ماندن در صفحه',
    ACCIDENTALLY_CLOSED_ACCEPT_BUTTON: 'بستن صفحه',
};
const fullChartFaMessages = {
    FULL_CHART_PLACEHOLDER_TEXT: 'داده‌ای برای نمایش وجود ندارد',
};
const dragAndDropFaMessages = {
    DRAG_AND_DROP_DELETE_BUTTON: 'حذف فایل',
    DRAG_AND_DROP_DOWNLOAD_BUTTON: 'دانلود فایل',
};
const notifFaMessages = {
    NOTIF_CLOSE_BUTTON: 'بستن',
};
const countDownTimerFaMessage = {
    RESTART_BUTTON_TEXT: 'شروع دوباره',
    RESTART_BUTTON_TEXT_CONJUNCTION: 'تا',
};
const faMessages = {
    ...conditionBuilderFaMessages,
    ...dateRangePickerFaMessages,
    ...filterChipsFaMessages,
    ...ssoFaMessages,
    ...confirmDialogFaMessages,
    ...accidentallyClosedFaMessage,
    ...fullChartFaMessages,
    ...dragAndDropFaMessages,
    ...notifFaMessages,
    ...countDownTimerFaMessage,
};

class TranslateService {
    constructor(currentLanguage) {
        this.currentLanguage = currentLanguage;
    }
    translate(key) {
        if (!key)
            return '';
        if (this.currentLanguage === 'fa' && faMessages[key])
            return faMessages[key];
        else if (this.currentLanguage === 'en' && enMessages[key])
            return enMessages[key];
        else
            return key;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: TranslateService, deps: [{ token: PGH_LANGUAGE_CONFIG }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: TranslateService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: TranslateService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [PGH_LANGUAGE_CONFIG]
                }] }] });

class TranslatePipe {
    constructor(translateService) {
        this.translateService = translateService;
    }
    transform(key) {
        return this.translateService.translate(key);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: TranslatePipe, deps: [{ token: TranslateService }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.2.13", ngImport: i0, type: TranslatePipe, isStandalone: false, name: "translate" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: TranslatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'translate',
                    standalone: false,
                }]
        }], ctorParameters: () => [{ type: TranslateService }] });

class TranslateModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: TranslateModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.13", ngImport: i0, type: TranslateModule, declarations: [TranslatePipe], imports: [CommonModule], exports: [TranslatePipe] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: TranslateModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.13", ngImport: i0, type: TranslateModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [TranslatePipe],
                    imports: [CommonModule],
                    exports: [TranslatePipe],
                }]
        }] });

/*
 * Public API Surface of @tapsellorg/angular-material-library
 */

/**
 * Generated bundle index. Do not edit.
 */

export { PGH_LANGUAGE_CONFIG, TranslateModule, TranslatePipe, TranslateService };
//# sourceMappingURL=tapsellorg-angular-material-library.mjs.map
