import { AfterViewInit, ElementRef, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { UntypedFormControl } from '@angular/forms';
import { MatAutocompleteSelectedEvent, MatAutocompleteTrigger } from '@angular/material/autocomplete';
import { MatChipInputEvent } from '@angular/material/chips';
import { PghAutoCompleteSelectionChange } from './model';
import * as i0 from "@angular/core";
declare const PghAutoCompleteComponent_base: (new (...args: any[]) => {
    _destroyed$: import("rxjs").Subject<unknown>;
    ngOnDestroy(): void;
}) & (new (...args: any[]) => {});
export declare class PghAutoCompleteComponent<T = any> extends PghAutoCompleteComponent_base implements OnInit, OnChanges, AfterViewInit {
    readonly SEPARATOR_KEYS_CODES: number[];
    label: import("@angular/core").InputSignal<string | undefined>;
    placeholder: import("@angular/core").InputSignal<string>;
    maxCount: import("@angular/core").InputSignal<number | undefined>;
    onlyDistinctValues: import("@angular/core").InputSignal<boolean>;
    allowCustomValues: import("@angular/core").InputSignal<boolean>;
    allowChipInputAddOnBlur: import("@angular/core").InputSignal<boolean>;
    allValues: import("@angular/core").InputSignal<T[]>;
    selectedValues: import("@angular/core").ModelSignal<T[]>;
    selectedValuesChange: import("@angular/core").OutputEmitterRef<T[]>;
    selectionChange: import("@angular/core").OutputEmitterRef<PghAutoCompleteSelectionChange<T>>;
    selectedValuesControl: import("@angular/core").InputSignal<UntypedFormControl | undefined>;
    inputCtrl: import("@angular/core").InputSignal<UntypedFormControl>;
    filteredValues: import("@angular/core").WritableSignal<T[]>;
    inputElm?: ElementRef<HTMLInputElement>;
    matAutocompleteTrigger?: MatAutocompleteTrigger;
    hasAutoComplete: boolean;
    valueProperty: import("@angular/core").InputSignal<string | undefined>;
    nameProperty: import("@angular/core").InputSignal<string | undefined>;
    valueGetter: (x: T) => string | T;
    nameGetter: (x: T) => string;
    constructor();
    private emit;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    private handleClosePanel;
    private addAlreadyExistedValues;
    add(event: MatChipInputEvent): void;
    remove(val: T): void;
    private findEligibleValue;
    private pushToSelectedValues;
    onSelectOption(event: MatAutocompleteSelectedEvent): void;
    private _filter;
    private calculatePossibleValues;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghAutoCompleteComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghAutoCompleteComponent<any>, "pgh-auto-complete", never, { "label": { "alias": "label"; "required": false; "isSignal": true; }; "placeholder": { "alias": "placeholder"; "required": false; "isSignal": true; }; "maxCount": { "alias": "maxCount"; "required": false; "isSignal": true; }; "onlyDistinctValues": { "alias": "onlyDistinctValues"; "required": false; "isSignal": true; }; "allowCustomValues": { "alias": "allowCustomValues"; "required": false; "isSignal": true; }; "allowChipInputAddOnBlur": { "alias": "allowChipInputAddOnBlur"; "required": false; "isSignal": true; }; "allValues": { "alias": "allValues"; "required": false; "isSignal": true; }; "selectedValues": { "alias": "selectedValues"; "required": false; "isSignal": true; }; "selectedValuesControl": { "alias": "selectedValuesControl"; "required": false; "isSignal": true; }; "inputCtrl": { "alias": "inputCtrl"; "required": false; "isSignal": true; }; "valueProperty": { "alias": "valueProperty"; "required": false; "isSignal": true; }; "nameProperty": { "alias": "nameProperty"; "required": false; "isSignal": true; }; "valueGetter": { "alias": "valueGetter"; "required": false; }; "nameGetter": { "alias": "nameGetter"; "required": false; }; }, { "selectedValues": "selectedValuesChange"; "selectedValuesChange": "selectedValuesChange"; "selectionChange": "selectionChange"; }, never, never, false, never>;
}
export {};
