import { ChangeDetectorRef } from '@angular/core';
import { DateAdapter, MatDateFormats } from '@angular/material/core';
import { MatCalendar, MatDateRangePicker } from '@angular/material/datepicker';
import { JalaliDate } from '@tapsellorg/angular-material-library/src/lib/jalali-date-adapter';
import { PghDateRangePickerControllerService } from '../date-range-picker-controller.service';
import { PghPredefinedDate } from '../models';
import * as i0 from "@angular/core";
declare const PghDatePickerHeaderComponent_base: (new (...args: any[]) => {
    _destroyed$: import("rxjs").Subject<unknown>;
    ngOnDestroy(): void;
}) & (new (...args: any[]) => {});
export declare class PghDatePickerHeaderComponent extends PghDatePickerHeaderComponent_base {
    private calendar;
    private dateAdapter;
    private picker;
    private datePickerController;
    private dateFormats;
    currentPredefinedDate: import("@angular/core").WritableSignal<PghPredefinedDate | undefined>;
    predefinedDateRanges: import("@angular/core").WritableSignal<readonly PghPredefinedDate[]>;
    readonly isTouchUi: boolean;
    constructor(calendar: MatCalendar<JalaliDate>, dateAdapter: DateAdapter<JalaliDate>, picker: MatDateRangePicker<JalaliDate>, datePickerController: PghDateRangePickerControllerService, dateFormats: MatDateFormats, cdr: ChangeDetectorRef);
    get periodLabel(): string;
    selectRange(predefinedDate: PghPredefinedDate): void;
    private changeDate;
    previousClicked(mode: 'month' | 'year'): void;
    nextClicked(mode: 'month' | 'year'): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghDatePickerHeaderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghDatePickerHeaderComponent, "pgh-date-picker-header", never, {}, {}, never, never, false, never>;
}
export {};
