import { OnDestroy } from '@angular/core';
import { MaterialJalaliDateAdapter } from '@tapsellorg/angular-material-library/src/lib/jalali-date-adapter';
import { BehaviorSubject } from 'rxjs';
import { PghDateRangeChangeEvent, PghJalaliDateRange, PghPredefinedDate } from './models';
import * as i0 from "@angular/core";
export declare class PghDatePickerService implements OnDestroy {
    private dateAdapter;
    private fallBackPredefinedDate;
    private predefinedRangeCalculator;
    private readonly DATE_KEY;
    private readonly EXPIRATION_PERIOD;
    dateChange$: BehaviorSubject<PghDateRangeChangeEvent | undefined>;
    constructor(dateAdapter: MaterialJalaliDateAdapter, fallBackPredefinedDate: PghPredefinedDate);
    ngOnDestroy(): void;
    setDateRange(range: PghJalaliDateRange | undefined): void;
    setPredefinedDate(predefinedDate: PghPredefinedDate): void;
    private saveDateInLocalStorage;
    private localStorageListener;
    private isDateExpired;
    private getSavedDateFromLocalStorage;
    private extractLocalStorageValue;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghDatePickerService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PghDatePickerService>;
}
