import { OnDestroy } from '@angular/core';
import { MaterialJalaliDateAdapter } from '@tapsellorg/angular-material-library/src/lib/jalali-date-adapter';
import { BehaviorSubject } from 'rxjs';
import { PghDatePickerService } from './date-picker.service';
import { PghDatePickerItemId, PghEnrichedDateRange, PghJalaliDateRange, PghPredefinedDate } from './models';
import * as i0 from "@angular/core";
declare const PghDateRangePickerControllerService_base: (new (...args: any[]) => {
    _destroyed$: import("rxjs").Subject<unknown>;
    ngOnDestroy(): void;
}) & (new (...args: any[]) => {});
export declare class PghDateRangePickerControllerService extends PghDateRangePickerControllerService_base implements OnDestroy {
    private dateAdapter;
    private synchronizationService;
    private predefinedRangeCalculator;
    readonly predefinedDates: readonly PghPredefinedDate[];
    private isSynced;
    private predefinedDate?;
    dateRange$: BehaviorSubject<PghEnrichedDateRange | undefined>;
    private syncServiceSubscription?;
    private emitDateRange;
    constructor(dateAdapter: MaterialJalaliDateAdapter, injectedDateRanges: PghPredefinedDate[], injectedExpandedDateRanges: PghPredefinedDate[], synchronizationService: PghDatePickerService);
    ngOnDestroy(): void;
    setSync(isSynced: boolean): void;
    setDateRange(range: PghJalaliDateRange): void;
    setPredefinedDate(predefinedDate: PghPredefinedDate | undefined): void;
    handleSynchronization(): void;
    setPredefinedDateById(id: PghDatePickerItemId): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghDateRangePickerControllerService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PghDateRangePickerControllerService>;
}
export {};
