import { OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { UntypedFormControl } from '@angular/forms';
import { PghDatePickerHeaderComponent } from './date-picker-header/date-picker-header.component';
import { PghDateRangePickerControllerService } from './date-range-picker-controller.service';
import { PghDatePickerItemId, PghDateRangeChangeEvent, PghEnrichedDateRange, PghPredefinedDate } from './models';
import { PghNotifService } from '@tapsellorg/angular-material-library/notif';
import { JalaliDate } from './constants';
import * as i0 from "@angular/core";
export declare class PghDateRangePickerComponent implements OnInit, OnChanges, OnDestroy {
    private dateRangePickerController;
    private pghNotifService;
    readonly headerComponent: typeof PghDatePickerHeaderComponent;
    start: import("@angular/core").InputSignal<UntypedFormControl>;
    end: import("@angular/core").InputSignal<UntypedFormControl>;
    maxRange: import("@angular/core").InputSignal<number | undefined>;
    isSynced: import("@angular/core").InputSignal<boolean>;
    expanded: import("@angular/core").InputSignal<boolean>;
    disableClickOnInputs: import("@angular/core").InputSignal<boolean>;
    defaultSelectedDateRangeId: import("@angular/core").InputSignal<PghDatePickerItemId | undefined>;
    disabledDates: import("@angular/core").InputSignal<string[] | undefined>;
    rangeChange: import("@angular/core").OutputEmitterRef<PghDateRangeChangeEvent>;
    private readonly destroy$;
    private selectedDateRange?;
    selectedChip: import("@angular/core").WritableSignal<PghDatePickerItemId | undefined>;
    chipDateRanges: import("@angular/core").WritableSignal<PghPredefinedDate[]>;
    constructor(dateRangePickerController: PghDateRangePickerControllerService, pghNotifService: PghNotifService, injectedExpandedDateRanges: PghPredefinedDate[]);
    ngOnInit(): void;
    changeSelection(id: PghDatePickerItemId): void;
    jalaliDateToISOString(jalaliDate: JalaliDate): string;
    dateClass: (date: JalaliDate) => string;
    isDateDisabled(date: string): boolean;
    getDatesBetween(startDate: string, endDate: string): string[];
    isDateRangeValid(startDate: any, endDate: any): boolean;
    incrementDate(date: string): string;
    datePickerDateChange(): void;
    setDefaultDateRange(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    emitRange(range: PghEnrichedDateRange | undefined): void;
    getSelectedDateRange(): PghDateRangeChangeEvent | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghDateRangePickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghDateRangePickerComponent, "pgh-date-range-picker", never, { "start": { "alias": "start"; "required": false; "isSignal": true; }; "end": { "alias": "end"; "required": false; "isSignal": true; }; "maxRange": { "alias": "maxRange"; "required": false; "isSignal": true; }; "isSynced": { "alias": "isSynced"; "required": false; "isSignal": true; }; "expanded": { "alias": "expanded"; "required": false; "isSignal": true; }; "disableClickOnInputs": { "alias": "disableClickOnInputs"; "required": false; "isSignal": true; }; "defaultSelectedDateRangeId": { "alias": "defaultSelectedDateRangeId"; "required": false; "isSignal": true; }; "disabledDates": { "alias": "disabledDates"; "required": false; "isSignal": true; }; }, { "rangeChange": "rangeChange"; }, never, never, false, never>;
}
