import { JalaliDate } from '@tapsellorg/angular-material-library/src/lib/jalali-date-adapter';
export interface PghJalaliDateRange {
    start: JalaliDate;
    end: JalaliDate;
}
/**
 * @deprecated
 */
export type PghDateRange = PghJalaliDateRange;
export interface PghDateRangeChangeEvent extends PghEnrichedDateRange {
}
export interface PghEnrichedDateRange {
    start: JalaliDate;
    end: JalaliDate;
    startGregorian: Date;
    endGregorian: Date;
    startTimestamp: number;
    endTimestamp: number;
    predefined?: PghPredefinedDate;
}
export type PghPredefinedDate = {
    id: PghDatePickerItemId;
    type: 'relative';
    start: number;
    end: number;
    title: string;
} | {
    id: PghDatePickerItemId;
    type: 'week' | 'month' | 'year';
    from: number;
    title: string;
} | {
    id: PghDatePickerItemId;
    type: 'clearDate';
    title: string;
};
export interface PghDatePickerSavedItem {
    type: PghDatePickerItemType;
    lastChange: number;
    range?: PghJalaliDateRange | PghPredefinedDate;
}
export type PghDatePickerItemType = 'range' | 'predefined' | 'clearDate';
export type PghDatePickerItemId = 'today' | 'this month' | 'clear date' | 'last 7 days' | 'yesterday' | 'last 30 days' | 'last 60 days';
