export type WeekDay = 'SATURDAY' | 'SUNDAY' | 'MONDAY' | 'TUESDAY' | 'WEDNESDAY' | 'THURSDAY' | 'FRIDAY';
export declare const DaysDictionary: Map<WeekDay, string>;
export declare const days: WeekDay[];
export type HOURS = '00' | '01' | '02' | '03' | '04' | '05' | '06' | '07' | '08' | '09' | '10' | '11' | '12' | '13' | '14' | '15' | '16' | '17' | '18' | '19' | '20' | '21' | '22' | '23';
export declare const hours: HOURS[];
export interface HourItem {
    hour: HOURS;
    isSelected: boolean;
}
export type PghSelectedHoursModel = Record<string, {
    start: number;
    end: number;
}[]>;
export declare const HOUR_ITEMS: HourItem[];
export interface DayItem {
    id: string;
    name: WeekDay;
    isDaySelected: boolean;
    isDayHovered: boolean;
    hours: {
        hourId: HOURS;
        start: number;
        end: number;
        isHourHovered: boolean;
        isHourSelected: boolean;
    }[];
}
export declare const ALL_DAYS: DayItem[];
export declare const WEEKENDS: DayItem[];
export declare const WEEKDAYS: DayItem[];
