import { AfterContentInit, OnDestroy, QueryList } from '@angular/core';
import { PghFilterChipsMarkerDirective } from './filter-chips.directive';
import { PghFilterChipItemsConnectorOptions, PghFilterChipsItem, PghFilterChipsSearchEvent } from './models';
import { PghFilterChipsPersistService } from './filter-chips-persist.service';
import * as i0 from "@angular/core";
declare const PghFilterChipsComponent_base: (new (...args: any[]) => {
    _destroyed$: import("rxjs").Subject<unknown>;
    ngOnDestroy(): void;
}) & (new (...args: any[]) => {});
export declare class PghFilterChipsComponent extends PghFilterChipsComponent_base implements AfterContentInit, OnDestroy {
    private filterChipsPersistService;
    filterMarkers?: QueryList<PghFilterChipsMarkerDirective>;
    private connectedFilterMarkersViaConnectorProvider;
    showSearchButton: import("@angular/core").InputSignal<boolean>;
    persistId: import("@angular/core").InputSignal<string | null>;
    search: import("@angular/core").OutputEmitterRef<PghFilterChipsSearchEvent>;
    filterItems: import("@angular/core").WritableSignal<PghFilterChipsItem<any>[]>;
    get allFilterMarkers(): PghFilterChipsMarkerDirective[];
    constructor(filterChipsPersistService: PghFilterChipsPersistService, filterChipsMarkerConnector: PghFilterChipItemsConnectorOptions);
    private getPersistedData;
    ngAfterContentInit(): void;
    get hasNoInactiveFilter(): boolean;
    private handleFilterMarkersChange;
    private setupFilterValueChangesListener;
    onSelectFilterItem(filterItem: PghFilterChipsItem): void;
    private emitFilterValues;
    private persistData;
    onClickSearch(): void;
    ngOnDestroy(): void;
    private getPersistId;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghFilterChipsComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghFilterChipsComponent, "pgh-filter-chips", never, { "showSearchButton": { "alias": "showSearchButton"; "required": false; "isSignal": true; }; "persistId": { "alias": "persistId"; "required": false; "isSignal": true; }; }, { "search": "search"; }, ["filterMarkers"], never, false, never>;
}
export {};
