import { JalaliDate } from './jalali-date';
export declare class DateUtils {
    static ISO_DATE_REGEX: RegExp;
    static isDateStringIso(dateString: string): boolean;
    static getTodayJalali(): JalaliDate;
    static jalaliToGregorian(date: JalaliDate): Date;
    static gregorianToJalali(date: Date): JalaliDate;
    static isValidDate(date: any): date is Date;
    static format(date: Date, format?: string): string;
    /**
     * @deprecated use DateUtils.milliSecsToMinSecsConverter(milliSecs)
     * @param milliSecs
     */
    static miliSecsToMinSecsConverter(milliSecs: number): {
        minutes: number;
        seconds: number;
    };
    static milliSecsToMinSecsConverter(milliSecs: number): {
        minutes: number;
        seconds: number;
    };
    static isDateToday(_date: Date | string): boolean;
    static daysBetween(_date1: string | Date, _date2: string | Date): number;
    static jalaliDaysBetween(_date1: JalaliDate, _date2: JalaliDate): number;
    static getHourAndMinuteDate(date: Date): string;
    static getOnlyDateISO(date: Date | string | number): string | null;
    static calculateFromAndToOfDateRange(dateRange: {
        length: number;
        to: number;
    }): {
        fromJalali: JalaliDate;
        toJalali: JalaliDate;
        fromDate: Date;
        toDate: Date;
    };
}
