import { DateAdapter } from '@angular/material/core';
import { JalaliDate } from './jalali-date';
export declare class MaterialJalaliDateAdapter extends DateAdapter<JalaliDate> {
    private readonly dayNames;
    constructor();
    getYear(date: JalaliDate): number;
    getMonth(date: JalaliDate): number;
    getDate(date: JalaliDate): number;
    getDayOfWeek(date: JalaliDate): number;
    getMonthNames(style: 'long' | 'short' | 'narrow'): string[];
    getDateNames(): string[];
    getDayOfWeekNames(style: 'long' | 'short' | 'narrow'): string[];
    getYearName(date: JalaliDate): string;
    getFirstDayOfWeek(): number;
    getNumDaysInMonth(date: JalaliDate): number;
    clone(date: JalaliDate): JalaliDate;
    createDate(year: number, month: number, date: number): JalaliDate;
    today(): JalaliDate;
    parse(value: any, parseFormat: string | string[]): JalaliDate | null;
    format(date: JalaliDate, displayFormat: string): string;
    addCalendarYears(date: JalaliDate, years: number): JalaliDate;
    addCalendarMonths(date: JalaliDate, months: number): JalaliDate;
    addCalendarDays(date: JalaliDate, days: number): JalaliDate;
    toIso8601(date: JalaliDate): string;
    isDateInstance(obj: any): boolean;
    isValid(date: JalaliDate): boolean;
    isLeapYear(year: number): boolean;
    invalid(): JalaliDate;
    deserialize(value: any): JalaliDate | null;
    sameDate(first: JalaliDate | null, second: JalaliDate | null): boolean;
    compareDate(first: JalaliDate, second: JalaliDate): number;
}
