import { Observable } from 'rxjs';
import { PghLoaderConfig, PghLoaderToggleable, PghLoaderType } from './loader.models';
export declare class PghLoader implements PghLoaderToggleable {
    config: PghLoaderConfig;
    loaderType: PghLoaderType;
    private readonly _active$;
    get active$(): Observable<boolean>;
    /**
     * This shows if any data is ever loaded
     * It's like `!is` but at first it's false
     * Useful for empty state
     */
    isDataLoaded: boolean;
    private _loaderActive;
    get isActive(): boolean;
    private setLoaderState;
    constructor(loaderType?: PghLoaderType | null, config?: PghLoaderConfig | null);
    activate(): void;
    deactivate(): void;
}
