import { AfterViewChecked, AfterViewInit, ElementRef, OnDestroy, OnInit, QueryList } from '@angular/core';
import * as i0 from "@angular/core";
export declare class PghPinInputComponent implements AfterViewInit, OnInit, OnDestroy, AfterViewChecked {
    inputsList: QueryList<ElementRef>;
    readonly codeLength: import("@angular/core").InputSignal<number>;
    readonly inputType: import("@angular/core").InputSignal<string>;
    readonly inputMode: import("@angular/core").InputSignal<string>;
    readonly initialFocusField: import("@angular/core").InputSignal<number>;
    readonly isCharsCode: import("@angular/core").InputSignal<boolean>;
    readonly isCodeHidden: import("@angular/core").InputSignal<boolean>;
    readonly isPrevFocusableAfterClearing: import("@angular/core").InputSignal<boolean>;
    readonly isFocusingOnLastByClickIfFilled: import("@angular/core").InputSignal<boolean>;
    readonly disabled: import("@angular/core").InputSignal<boolean>;
    readonly autocapitalize: import("@angular/core").InputSignal<string>;
    readonly code: import("@angular/core").InputSignal<string | number>;
    readonly codeChanged: import("@angular/core").OutputEmitterRef<string>;
    readonly codeCompleted: import("@angular/core").OutputEmitterRef<string>;
    codeLengthEffect: import("@angular/core").EffectRef;
    codeEffect: import("@angular/core").EffectRef;
    placeholders: number[];
    private inputs;
    private inputsStates;
    private inputsListSubscription;
    private state;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    ngOnDestroy(): void;
    reset(isChangesEmitting?: boolean): void;
    focusOnField(index: number): void;
    onClick(e: any): void;
    onInput(e: any, i: number): void;
    onPaste(e: ClipboardEvent, i: number): void;
    onKeydown(e: any, i: number): Promise<void>;
    private onInputCodeChanges;
    private onCodeLengthChanges;
    private onInputsListChanges;
    private focusOnInputAfterAppearing;
    private emitChanges;
    private emitCode;
    private getCurrentFilledCode;
    private isBackspaceKey;
    private isDeleteKey;
    private setInputValue;
    private canInputValue;
    private setStateForInput;
    private getStateForInput;
    private isEmpty;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghPinInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghPinInputComponent, "pgh-pin-input", never, { "codeLength": { "alias": "codeLength"; "required": false; "isSignal": true; }; "inputType": { "alias": "inputType"; "required": false; "isSignal": true; }; "inputMode": { "alias": "inputMode"; "required": false; "isSignal": true; }; "initialFocusField": { "alias": "initialFocusField"; "required": false; "isSignal": true; }; "isCharsCode": { "alias": "isCharsCode"; "required": false; "isSignal": true; }; "isCodeHidden": { "alias": "isCodeHidden"; "required": false; "isSignal": true; }; "isPrevFocusableAfterClearing": { "alias": "isPrevFocusableAfterClearing"; "required": false; "isSignal": true; }; "isFocusingOnLastByClickIfFilled": { "alias": "isFocusingOnLastByClickIfFilled"; "required": false; "isSignal": true; }; "disabled": { "alias": "disabled"; "required": false; "isSignal": true; }; "autocapitalize": { "alias": "autocapitalize"; "required": false; "isSignal": true; }; "code": { "alias": "code"; "required": false; "isSignal": true; }; }, { "codeChanged": "codeChanged"; "codeCompleted": "codeCompleted"; }, never, never, true, never>;
}
