export type PghStatusDefaultLabelTypes = 'success' | 'danger' | 'warning' | 'info' | 'primary' | 'accent';
export interface PghStatusTypeDef {
    colorCode: string;
    iconName?: string;
}
export type PghStatusTypeMappings<TYPES extends string> = Record<TYPES, string[]>;
/**
 * additionalTypes: If you have other types with different styles (like blue or purple)
 * typesMapping: You can map other strings to existing types
 */
export interface PghStatusLabelConfig<TYPES extends string> {
    typesMapping?: PghStatusTypeMappings<TYPES | PghStatusDefaultLabelTypes>;
    additionalTypes?: Record<TYPES, PghStatusTypeDef>;
    showIcon?: boolean;
    labelSize?: PghStatusLabelSize;
    styleMode?: PghStatusLabelStyleMode;
}
export type PghStatusLabelSize = 'mini' | 'medium' | 'large';
export type PghStatusLabelStyleMode = 'stroked' | 'filled';
