import { AfterViewInit, OnChanges, OnInit, SimpleChanges, TemplateRef } from '@angular/core';
import { MatTreeFlatDataSource, MatTreeFlattener } from '@angular/material/tree';
import { SelectionModel } from '@angular/cdk/collections';
import { FlatTreeControl } from '@angular/cdk/tree';
import { PghTreeData, PghTreeFlatNode, PghTreeLabel, PghTreeNode } from './tree.constants';
import { PghTreeService } from './tree.service';
import * as i0 from "@angular/core";
export declare class PghTreeComponent implements OnInit, OnChanges, AfterViewInit {
    private pghTreeService;
    protected readonly hasChild: (_: number, _nodeData: PghTreeFlatNode) => boolean;
    protected readonly hasNoContent: (_: number, _nodeData: PghTreeFlatNode) => boolean;
    protected readonly treeUtils: {
        treeControl: FlatTreeControl<PghTreeFlatNode> | undefined;
        setTreeControl(treeControl?: FlatTreeControl<PghTreeFlatNode>): void;
        removeEstimateCount(str: string): string;
        getFullPathWithoutEstimateCount(node: PghTreeFlatNode): string[];
        cutTreeDataUpToLevel(tree: PghTreeData | string[], depth: number): PghTreeData;
        createTreeFlattener(flatNodeMap: Map<PghTreeFlatNode, PghTreeNode>, nestedNodeMap: Map<PghTreeNode, PghTreeFlatNode>): MatTreeFlattener<PghTreeNode, PghTreeFlatNode>;
        getParentNodes(node: PghTreeFlatNode, shouldReturnAllNodes?: boolean): PghTreeFlatNode[];
        getChildrenNodes(node: PghTreeFlatNode): PghTreeFlatNode[];
        getSelectedNodes(selectedPaths: string[][]): PghTreeFlatNode[] | undefined;
        handleTreeExpansion(shouldExpandTree: boolean): void;
    };
    treeDataSource: import("@angular/core").InputSignal<PghTreeData | undefined>;
    treeLabels: import("@angular/core").InputSignal<PghTreeLabel | undefined>;
    treeDataSourceDepth: import("@angular/core").InputSignal<number>;
    selectable: import("@angular/core").InputSignal<boolean>;
    shouldExpandTree: import("@angular/core").InputSignal<boolean>;
    canAddChildNode: import("@angular/core").InputSignal<boolean>;
    selectedPaths: import("@angular/core").InputSignal<string[][]>;
    selectedItemsChanged: import("@angular/core").OutputEmitterRef<PghTreeNode[]>;
    treeControl: import("@angular/core").WritableSignal<FlatTreeControl<PghTreeFlatNode, PghTreeFlatNode> | undefined>;
    dataSource: import("@angular/core").WritableSignal<MatTreeFlatDataSource<PghTreeNode, PghTreeFlatNode, PghTreeFlatNode> | undefined>;
    checklistSelection: import("@angular/core").WritableSignal<SelectionModel<PghTreeFlatNode>>;
    flatNodeMap: Map<PghTreeFlatNode, PghTreeNode>;
    nestedNodeMap: Map<PghTreeNode, PghTreeFlatNode>;
    treeFlattener: MatTreeFlattener<PghTreeNode, PghTreeFlatNode>;
    customNodeItemTemplate?: TemplateRef<any>;
    customElementTemplate?: TemplateRef<any>;
    constructor(pghTreeService: PghTreeService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    initializeTree(): void;
    onChangeTree(): void;
    patchSelectedNodes(): void;
    leafItemSelectionToggle(node: PghTreeFlatNode): void;
    addNewItem(node: PghTreeFlatNode): void;
    saveNode(node: PghTreeFlatNode, itemValue: string): void;
    descendantsAllSelected(node: PghTreeFlatNode): boolean | undefined;
    descendantsPartiallySelected(node: PghTreeFlatNode): boolean | undefined;
    parentItemSelectionToggle(node: PghTreeFlatNode): void;
    checkAllParentsSelection(node: PghTreeFlatNode): void;
    checkRootNodeSelection(node: PghTreeFlatNode): void;
    flatNodeToNestedNode(selectedOption: PghTreeFlatNode): PghTreeNode;
    storeSelectedNodes(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PghTreeComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PghTreeComponent, "pgh-tree", never, { "treeDataSource": { "alias": "treeDataSource"; "required": false; "isSignal": true; }; "treeLabels": { "alias": "treeLabels"; "required": false; "isSignal": true; }; "treeDataSourceDepth": { "alias": "treeDataSourceDepth"; "required": false; "isSignal": true; }; "selectable": { "alias": "selectable"; "required": false; "isSignal": true; }; "shouldExpandTree": { "alias": "shouldExpandTree"; "required": false; "isSignal": true; }; "canAddChildNode": { "alias": "canAddChildNode"; "required": false; "isSignal": true; }; "selectedPaths": { "alias": "selectedPaths"; "required": false; "isSignal": true; }; }, { "selectedItemsChanged": "selectedItemsChanged"; }, ["customNodeItemTemplate", "customElementTemplate"], never, false, never>;
}
