export interface PghTreeNode {
    children?: PghTreeNode[];
    item: string;
    parents?: PghTreeNode[];
    label?: string;
}
export interface PghTreeFlatNode {
    item: string;
    level: number;
    expandable: boolean;
}
export interface PghTreeData {
    [key: string]: PghTreeData | null | string[];
}
export type PghTreeLabel = Record<string, string>;
export declare const getLevel: (node: PghTreeFlatNode) => number;
export declare const isExpandable: (node: PghTreeFlatNode) => boolean;
export declare const getChildren: (node: PghTreeNode) => PghTreeNode[] | undefined;
export declare const hasChild: (_: number, _nodeData: PghTreeFlatNode) => boolean;
export declare const hasNoContent: (_: number, _nodeData: PghTreeFlatNode) => boolean;
