import { PghTreeData, PghTreeFlatNode, PghTreeNode } from './tree.constants';
import { MatTreeFlattener } from '@angular/material/tree';
import { FlatTreeControl } from '@angular/cdk/tree';
export declare const TreeUtils: {
    treeControl: FlatTreeControl<PghTreeFlatNode> | undefined;
    setTreeControl(treeControl?: FlatTreeControl<PghTreeFlatNode>): void;
    removeEstimateCount(str: string): string;
    getFullPathWithoutEstimateCount(node: PghTreeFlatNode): string[];
    cutTreeDataUpToLevel(tree: PghTreeData | string[], depth: number): PghTreeData;
    createTreeFlattener(flatNodeMap: Map<PghTreeFlatNode, PghTreeNode>, nestedNodeMap: Map<PghTreeNode, PghTreeFlatNode>): MatTreeFlattener<PghTreeNode, PghTreeFlatNode>;
    getParentNodes(node: PghTreeFlatNode, shouldReturnAllNodes?: boolean): PghTreeFlatNode[];
    getChildrenNodes(node: PghTreeFlatNode): PghTreeFlatNode[];
    getSelectedNodes(selectedPaths: string[][]): PghTreeFlatNode[] | undefined;
    handleTreeExpansion(shouldExpandTree: boolean): void;
};
