import { PghErrorResponse, PghSsoAuthData, PghSsoIframeAuthData, PghSsoIframeLogout, PghSsoIframeMessage, PghTokenPayload } from './models';
export declare class PghSsoUtils {
    static readonly AUTH_DATA_REQUIRED_KEYS: (keyof PghSsoAuthData)[];
    static readonly AUTH_DATA_KEYS: (keyof PghSsoAuthData)[];
    static readonly UUID_PARAM = "uuid";
    static validateAuthData(data: Partial<PghSsoAuthData>): data is PghSsoAuthData;
    static isTokenMessage(data: PghSsoIframeMessage): data is PghSsoIframeAuthData;
    static isLogoutMessage(data: PghSsoIframeMessage): data is PghSsoIframeLogout;
    static decodeJwtToken(accessToken: string): PghTokenPayload;
    static parseError(error: unknown): PghErrorResponse;
}
